# A Dvorak Type II based board

As I switched from a Poker II some keys are based on my experience there.


## DVORAK (Normal) Layer
```
,-----------------------------------------------------------------------------------.
 | ESC  |   Ü  |   ,  |   .  |   P  |   Y  |   F  |   G  |   C  |   T  |   Z  | Bksp |
 |------+------+------+------+------+-------------+------+------+------+------+------|
 | TAB  |   A  |   O  |   E  |   I  |   U  |   H  |   D  |   R  |   N  |   S  |  L   |
 |------+------+------+------+------+------|------+------+------+------+------+------|
 | Shift|   Ä  |   Ö  |   Q  |   J  |   K  |   X  |   B  |   M  |   W  |   V  |Enter |
 |------+------+------+------+------+------+------+------+------+------+------+------|
 | CTRL |  OS  | Alt  | MO(3)|Lower |    Space    |Raise | Left |Right |  Up  |Down  |
 `-----------------------------------------------------------------------------------'
```

## Lower
```
,-----------------------------------------------------------------------------------.
 |   ~  |   !  |   @  |   #  |   $  |   %  |   ^  |   &  |   *  |   (  |   )  | Bksp |
 |------+------+------+------+------+-------------+------+------+------+------+------|
 | Del  |  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |   _  |   +  |   {  |   }  |  |   |
 |------+------+------+------+------+------|------+------+------+------+------+------|
 |      |  F7  |  F8  |  F9  |  F10 |  F11 |  F12 |ISO ~ |ISO | | Home | End  |  ?   |
 |------+------+------+------+------+------+------+------+------+------+------+------|
 |      |      |      |      |      |             |      | Next | Vol- | Vol+ | Play |
 `-----------------------------------------------------------------------------------'
```

## Raise
```
,-----------------------------------------------------------------------------------.
 |   `  |   1  |   2  |   3  |   4  |   5  |   6  |   7  |   8  |   9  |   0  | Bksp |
 |------+------+------+------+------+-------------+------+------+------+------+------|
 | Del  |  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |   -  |   =  |   [  |   ]  |  \   |
 |------+------+------+------+------+------|------+------+------+------+------+------|
 |      |  F7  |  F8  |  F9  |  F10 |  F11 |  F12 |ISO # |ISO / |Pg Up |Pg Dn |  /   |
 |------+------+------+------+------+------+------+------+------+------+------+------|
 |      |      |      |      |      |             |      | Next | Vol- | Vol+ | Play |
 `-----------------------------------------------------------------------------------'
```

## Adjust (MO(3))
```
   ,-----------------------------------------------------------------------------------.
   |      | HOME |  UP  |  END |      |      |      |      |      |      |      |  Del |
   |------+------+------+------+------+-------------+------+------+------+------+------|
   |      | LEFT | DOWN | RIGHT|      |      |      |      |      |      |      |      |
   |------+------+------+------+------+------|------+------+------+------+------+------|
   |      |      |      |      |      |      |      |      |      |      |      |      |
   |------+------+------+------+------+------+------+------+------+------+------+------|
   |      |      |      |      |      |             |      |      |      |      |      |
   `-----------------------------------------------------------------------------------'
```