#include "curry.h"

#define LAYOUT_crkbd_base( \
        K01, K02, K03, K04, K05, K06, K07, K08, K09, K0A, \
        K11, K12, K13, K14, K15, K16, K17, K18, K19, K1A, \
        K21, K22, K23, K24, K25, K26, K27, K28, K29, K2A  \
    ) \
    LAYOUT_wrapper( \
        KC_ESC,  K01, K02, K03, K04, K05,      K06, K07, K08, K09, K0A, KC_MINS, \
        MT_TAB,  K11, K12, K13, K14, K15,      K16, K17, K18, K19, K1A, KC_QUOT, \
        OS_LSFT, K21, K22, K23, K24, K25,      K26, K27, K28, K29, K2A, OS_RSFT, \
                KC_LEAD,OS_LALT, SP_LWER,      ET_RAIS, KC_BSPC, KC_RGUI         \
    )
#define LAYOUT_crkbd_base_wrapper(...)       LAYOUT_crkbd_base(__VA_ARGS__)

const uint16_t PROGMEM keymaps[][MATRIX_ROWS][MATRIX_COLS] = {
    [_QWERTY] = LAYOUT_crkbd_base_wrapper(
        _________________QWERTY_L1_________________, _________________QWERTY_R1_________________,
        _________________QWERTY_L2_________________, _________________QWERTY_R2_________________,
        _________________QWERTY_L3_________________, _________________QWERTY_R3_________________
    ),

    [_COLEMAK] = LAYOUT_crkbd_base_wrapper(
        _________________COLEMAK_L1________________, _________________COLEMAK_R1________________,
        _________________COLEMAK_L2________________, _________________COLEMAK_R2________________,
        _________________COLEMAK_L3________________, _________________COLEMAK_R3________________
    ),

    [_DVORAK] = LAYOUT_crkbd_base_wrapper(
        _________________DVORAK_L1_________________, _________________DVORAK_R1_________________,
        _________________DVORAK_L2_________________, _________________DVORAK_R2_________________,
        _________________DVORAK_L3_________________, _________________DVORAK_R3_________________
    ),

    [_WORKMAN] = LAYOUT_crkbd_base_wrapper(
        _________________WORKMAN_L1________________, _________________WORKMAN_R1________________,
        _________________WORKMAN_L2________________, _________________WORKMAN_R2________________,
        _________________WORKMAN_L3________________, _________________WORKMAN_R3________________
    ),

    [_MODS] = LAYOUT_wrapper(
        _______, ___________________BLANK___________________,       ___________________BLANK___________________, _______,
        _______, ___________________BLANK___________________,       ___________________BLANK___________________, _______,
        KC_LSFT, ___________________BLANK___________________,       ___________________BLANK___________________, KC_RSFT,
                                   _______, _______, _______,       _______, _______, _______
    ),

    [_LOWER] = LAYOUT_wrapper(
        KC_F11,  _________________LOWER_L1__________________,       _________________LOWER_R1__________________, KC_F12,
        KC_GRV,  _________________LOWER_L2__________________,       _________________LOWER_R2__________________, KC_PIPE,
        _______, _________________LOWER_L3__________________,       _________________LOWER_R3__________________, _______,
                                   _______, _______, _______,       _______, _______, _______
    ),

    [_RAISE] = LAYOUT_wrapper( \
        _______, _________________RAISE_L1__________________,       _________________RAISE_R1__________________, _______,
        _______, _________________RAISE_L2__________________,       _________________RAISE_R2__________________, KC_BSLS,
        _______, _________________RAISE_L3__________________,       _________________RAISE_R3__________________, _______,
                                   _______, _______, _______,       _______, _______, _______
    ),

    [_ADJUST] = LAYOUT_wrapper( \
        KC_MAKE, _________________ADJUST_L1_________________,       _________________ADJUST_R1_________________, KC_RST,
        VRSN,    _________________ADJUST_L2_________________,       _________________ADJUST_R2_________________, EEP_RST,
        MG_NKRO, _________________ADJUST_L3_________________,       _________________ADJUST_R3_________________, RGB_IDL,
                                   _______, _______, _______,       _______, TG_MODS, _______
    )
};
