### boris_burger's DZ60 layout

This layout is for a DZ60 with a 2U left shift, 1U right shift and an arrow cluster in
the bottom right.

It is based off stephengrier's layout adding support for Home/End/PgUp/PgDn using Fn+arrows
as used on macOS and Microsoft Surface. It has Insert instead of Fn near the arrow cluster
and other smaller tweaks:
- CapsLock is the only Fn key (CapsLock by itself is not available)
- Del is available as Fn+Backspace
- Ctrl+Del is available as Ctrl+Backspace (e.g. deleting word to the right of the cursor)
- Shift+Del is available as Shift+Backspace (e.g. permanently deleting file or e-mail)
- PgUp = Fn+Up
- PgDn = Fn+Down
- Home = Fn+Left
- End = Fn+Right
- Tilde = Shift+Esc 
- Backtick = Fn+Esc
- Underglow toggle and mode selection are available as Fn+Q and Fn+W
- Reset (bootloader mode) = Fn+B

### 0 Qwerty
```
,-----------------------------------------------------------------------------------------.
| Esc |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |  9  |  0  |  -  |  =  |   Bkspc   |
|-----------------------------------------------------------------------------------------+
| Tab    |  Q  |  W  |  E  |  R  |  T  |  Y  |  U  |  I  |  O  |  P  |  [  |  ]  |    \   |
|-----------------------------------------------------------------------------------------+
|   Fn    |  A  |  S  |  D  |  F  |  G  |  H  |  J  |  K  |  L  |  ;  |  '  |    Enter    |
|-----------------------------------------------------------------------------------------+
| Shift     |  Z  |  X  |  C  |  V  |  B  |  N  |  M  |  ,  |  .  |  /  | RSh |  U  | Ins |
|-----------------------------------------------------------------------------------------+
| Ctrl |  Win  |  Alt  |              Space                | Alt | Menu |  L  |  D  |  R  |
`-----------------------------------------------------------------------------------------'
```

### 1 Fn Layer
```
FN Layer
,-----------------------------------------------------------------------------------------.
|  `  |  F1 |  F2 |  F3 |  F4 |  F5 |  F6 |  F7 |  F8 |  F9 | F10 | F11 | F12 |    DEL    |
|-----------------------------------------------------------------------------------------+
|        |RBB T|RGB M| Hue+| Hue-| Sat+| Sat-| Val+| Val-|     |     |      |     |       |
|-----------------------------------------------------------------------------------------+
|         | BL T| BL M| BL+ | BL- |     |     |     |     |     |     |     |             |
|-----------------------------------------------------------------------------------------+
|           |     |     |     |     |RESET|     |     |     |     |     |     | PgUp|     |
|-----------------------------------------------------------------------------------------+
|      |       |       |                                   |     |      | Home| PgDn| End |
`-----------------------------------------------------------------------------------------'
```

