/* Copyright 2020 OJtheTiny
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include QMK_KEYBOARD_H

enum layers{
    L0,
    L1,
    L2
};

const uint16_t PROGMEM keymaps [][MATRIX_ROWS][MATRIX_COLS] = {
    [L0] = LAYOUT( /* Base Layer */
      KC_ESC,  KC_Q, KC_W, KC_E, KC_R, KC_T, KC_Y, KC_U, KC_I, KC_O, KC_P, KC_BSPC,
      KC_CAPS,  KC_A, KC_S, KC_D, KC_F, KC_G, KC_H, KC_J, KC_K, KC_L,    KC_ENT,
      KC_LSFT,   KC_Z, KC_X, KC_C, KC_V, KC_B, KC_N, KC_M, KC_COMM,    KC_DOT,
      KC_LCTL,  KC_LGUI,             LT(L1, KC_SPC),              KC_RALT, MO(L2)
    ),
    [L1] = LAYOUT( /* Num Layer */
      KC_GRV, KC_1,    KC_2,    KC_3,    KC_4,    KC_5,    KC_6,    KC_7,  KC_8,    KC_9,    KC_0,    KC_MINS,
      KC_TAB, _______, _______, _______, _______, _______, KC_LEFT, KC_UP, KC_DOWN, KC_RGHT,      KC_BSLS,
      _______,   _______, _______, KC_PSCR, _______, _______, KC_LBRC, KC_RBRC, KC_MINS,      KC_SLSH,
      _______, _______,                             _______,                        _______, KC_EQL
    ),
    [L2] = LAYOUT( /* F-Keys */
      _______, KC_F1,   KC_F2,   KC_F3,   KC_F4,   KC_F5,   KC_F6,   KC_F7,   KC_F8,   KC_F9,      KC_F10,     KC_F11,
      _______,  KC_MPRV, KC_MPLY, KC_MNXT, _______, _______,  _______, _______, KC_SCLN, KC_QUOT,    KC_ENT,
      _______,    KC_VOLD,  _______,  KC_VOLU, _______, _______, _______, _______, _______,            _______,
      _______, _______,                              _______,                           _______, _______
    )
};
