# Stamm layouts for ergodox_ez

4 layers:

* QUERTY
* Numbers
* Mouse
* Arrows

On home row there are hold dual keys:
- shift, ctrl, alt, cmd — on the fingers on the left hand
- cmd, alt, ctrl, shift — mirrored on the finger on the righ hand

Top row behaves like shifter numbers row.
Hold E switch to layer with numbers.
Hold R switch to mouse controll layer.

```
                                              0_Base
╭────────┬─────┬─────┬─────┬─────┬─────┬─────╮      ╭─────┬─────┬─────┬─────┬─────┬─────┬────────╮
│   `    │  !  │  @  │  #  │  $  │  %  │Mute │      │Capsl│  ^  │  &  │  *  │  (  │  )  │   -    │
├────────┼─────┼─────┼─────┼─────┼─────┼─────┤      ├─────┼─────┼─────┼─────┼─────┼─────┼────────┤
│  Lead  │  Q  │  W  │E|LT1│R|LT2│  T  │     │      │     │  Y  │  U  │  I  │  O  │  P  │   [    │
├────────┼─────┼─────┼─────┼─────┼─────┤     │      │     ├─────┼─────┼─────┼─────┼─────┼────────┤
│Ctrl + B│A | ⇧│S | ⌃│D | ⌥│F | ⌘│  G  ├─────┤      ├─────┤  H  │J | ⌘│K | ⌥│L | ⌃│; | ⇧│   '    │
├────────┼─────┼─────┼─────┼─────┼─────┤     │      │  ]  ├─────┼─────┼─────┼─────┼─────┼────────┤
│   \    │  Z  │  X  │  C  │  V  │  B  │     │      │     │  N  │  M  │  ,  │  .  │  /  │   =    │
╰──┬─────┼─────┼─────┼─────┼─────┼─────┴─────╯      ╰─────┴─────┼─────┼─────┼─────┼─────┼─────┬──╯
   │⎇ + T│     │     │     │Arrow│                              │     │     │     │     │     │
   ╰─────┴─────┴─────┴─────┴─────╯ ╭─────┬─────╮  ╭─────┬─────╮ ╰─────┴─────┴─────┴─────┴─────╯
                                   │Vol- │Vol+ │  │Play │Next │
                             ╭─────┼─────┼─────┤  ├─────┼─────┼─────╮
                             │     │     │     │  │     │     │     │
                             │Enter│ Tab ├─────┤  ├─────┤Bspac│  ⎵  │
                             │     │     │ Esc │  │ Esc │     │     │
                             ╰─────┴─────┴─────╯  ╰─────┴─────┴─────╯

                                            1_Numbers
╭────────┬─────┬─────┬─────┬─────┬─────┬─────╮      ╭─────┬─────┬─────┬─────┬─────┬─────┬────────╮
│        │ F1  │ F2  │ F3  │ F4  │ F5  │     │      │     │ F6  │ F7  │ F8  │ F9  │ F10 │  F11   │
├────────┼─────┼─────┼─────┼─────┼─────┼─────┤      ├─────┼─────┼─────┼─────┼─────┼─────┼────────┤
│        │     │     │     │     │     │     │      │     │     │  7  │  8  │  9  │  *  │  F12   │
├────────┼─────┼─────┼─────┼─────┼─────┤     │      │     ├─────┼─────┼─────┼─────┼─────┼────────┤
│        │     │     │     │     │     ├─────┤      ├─────┤     │  4  │  5  │  6  │  +  │        │
├────────┼─────┼─────┼─────┼─────┼─────┤     │      │     ├─────┼─────┼─────┼─────┼─────┼────────┤
│        │     │     │     │     │     │     │      │     │     │  1  │  2  │  3  │  \  │        │
╰──┬─────┼─────┼─────┼─────┼─────┼─────┴─────╯      ╰─────┴─────┼─────┼─────┼─────┼─────┼─────┬──╯
   │Reset│     │     │     │     │                              │  0  │  .  │     │  =  │     │
   ╰─────┴─────┴─────┴─────┴─────╯ ╭─────┬─────╮  ╭─────┬─────╮ ╰─────┴─────┴─────┴─────┴─────╯
                                   │     │     │  │     │     │
                             ╭─────┼─────┼─────┤  ├─────┼─────┼─────╮
                             │     │     │     │  │     │     │     │
                             │     │     ├─────┤  ├─────┤     │     │
                             │     │     │     │  │     │     │     │
                             ╰─────┴─────┴─────╯  ╰─────┴─────┴─────╯

                                             2_Mouse
╭────────┬─────┬─────┬─────┬─────┬─────┬─────╮      ╭─────┬─────┬─────┬─────┬─────┬─────┬────────╮
│        │     │     │     │     │     │     │      │     │     │     │     │     │     │        │
├────────┼─────┼─────┼─────┼─────┼─────┼─────┤      ├─────┼─────┼─────┼─────┼─────┼─────┼────────┤
│        │     │     │     │     │     │     │      │RgbMo│RgbTo│MsBtn│MsUp │MsBtn│     │        │
├────────┼─────┼─────┼─────┼─────┼─────┤     │      │     ├─────┼─────┼─────┼─────┼─────┼────────┤
│        │     │     │     │     │     ├─────┤      ├─────┤RgbSl│MsLef│MsDow│MsRig│     │        │
├────────┼─────┼─────┼─────┼─────┼─────┤     │      │Toggl├─────┼─────┼─────┼─────┼─────┼────────┤
│        │     │     │     │     │     │     │      │     │     │MsWhU│     │MsWhD│     │        │
╰──┬─────┼─────┼─────┼─────┼─────┼─────┴─────╯      ╰─────┴─────┼─────┼─────┼─────┼─────┼─────┬──╯
   │     │     │     │     │     │                              │     │     │     │     │     │
   ╰─────┴─────┴─────┴─────┴─────╯ ╭─────┬─────╮  ╭─────┬─────╮ ╰─────┴─────┴─────┴─────┴─────╯
                                   │RgbHu│RgbHu│  │RgbVa│RgbVa│
                             ╭─────┼─────┼─────┤  ├─────┼─────┼─────╮
                             │     │     │     │  │     │     │     │
                             │     │     ├─────┤  ├─────┤     │     │
                             │     │     │     │  │     │     │     │
                             ╰─────┴─────┴─────╯  ╰─────┴─────┴─────╯

                                             3_Arrow
╭────────┬─────┬─────┬─────┬─────┬─────┬─────╮      ╭─────┬─────┬─────┬─────┬─────┬─────┬────────╮
│        │     │     │     │     │     │     │      │     │     │     │     │     │     │        │
├────────┼─────┼─────┼─────┼─────┼─────┼─────┤      ├─────┼─────┼─────┼─────┼─────┼─────┼────────┤
│        │     │     │     │     │     │     │      │     │     │     │     │     │     │        │
├────────┼─────┼─────┼─────┼─────┼─────┤     │      │     ├─────┼─────┼─────┼─────┼─────┼────────┤
│        │     │     │     │     │     ├─────┤      ├─────┤  ←  │  ↓  │  ↑  │  →  │     │        │
├────────┼─────┼─────┼─────┼─────┼─────┤     │      │     ├─────┼─────┼─────┼─────┼─────┼────────┤
│        │     │     │     │     │     │     │      │     │     │     │     │     │     │        │
╰──┬─────┼─────┼─────┼─────┼─────┼─────┴─────╯      ╰─────┴─────┼─────┼─────┼─────┼─────┼─────┬──╯
   │     │     │     │     │     │                              │     │     │     │     │     │
   ╰─────┴─────┴─────┴─────┴─────╯ ╭─────┬─────╮  ╭─────┬─────╮ ╰─────┴─────┴─────┴─────┴─────╯
                                   │     │     │  │     │     │
                             ╭─────┼─────┼─────┤  ├─────┼─────┼─────╮
                             │     │     │     │  │     │     │     │
                             │     │     ├─────┤  ├─────┤     │     │
                             │     │     │     │  │     │     │     │
                             ╰─────┴─────┴─────╯  ╰─────┴─────┴─────╯

```

Copyright &copy; 2020 Rustam Zagirov. Released under [GPL-2.0](/LICENSE).
