# Satan GH60 ISO-DE Layout with split backspace and right shift

![Layout Image](https://i.imgur.com/a7znS69.jpg)

## Default Layer
This ISO-DE based layout has a split backspace. the left part is the actual backspace and the right parts serves as a FN key.
The right shift is also split, with the right part serving as the del key.
```
/* Keymap _DEF: Default Layer
 * ,------------------------------------------------------------.
 * |Esc|  1|  2|  3|  4|  5|  6|  7|  8|  9|  0|  ß| ´|bcksp|fn1|
 * |------------------------------------------------------------|
 * |Tab  |  Q|  W|  E|  R|  T|  Z|  U|  I|  O|  P|  Ü|  +|      |
 * |----------------------------------------------------- Return|
 * |fn2   | A|  S|  D|  F|  G|  H|  J|  K|  L|  Ö|  Ä|  # |     |
 * |------------------------------------------------------------|
 * |Sft | < |  Y|  X|  C|  V|  B|  N|  M|  ,|  .|  -| RSft| del |
 * |------------------------------------------------------------|
 * |Ctrl|Win |Alt |         Space          |RAlt |Win |App|RCtrl|
 * `------------------------------------------------------------'
 */
```


## FN Key Layer 
The Function keys can be accessed when holding fn1 (right part of backspace)

```
/* Keymap _FNK: Function Keys
 * ,------------------------------------------------------------.
 * | ^ | F1| F2| F3| F4| F5| F6| F7| F8| F9| F0|F11|F12| Ins |  |
 * |------------------------------------------------------------|
 * |     |PGU| Up|PGD|   |   |   |Ins|Hom|PDU|   |   |   |      |
 * |-----------------------------------------------------       |
 * |     |Lft|Dwn|Rgt|   |   |   |Del|End|PGD|   |   |    |     |
 * |------------------------------------------------------------|
 * |    |   |   |   |   |   |   |   |   |   |   |   |     |     |
 * |------------------------------------------------------------|
 * |    |    |    |                        |     |    |   |     |
 * `------------------------------------------------------------'
 */
```

## Media and Mouse Layer
The Media Keys and Mouse control can be accessed when holding capslock (fn2)

```
/* Keymap _MEDIA: Media and Mouse Layer
 * ,------------------------------------------------------------.
 * |   |   |   |   |   |   |   |   |   |   |   |   |   |     |  |
 * |------------------------------------------------------------|
 * |     |   |   |   |   |   |   |MLC| MU|MRC|   |   |   |      |
 * |-----------------------------------------------------       |
 * |     |PRV|VLD|VLU|NXT|   |   | ML| MD| MR|   |   |    |     |
 * |------------------------------------------------------------|
 * |    |   |   |   |   |   |   |   |   |   |   |   | UP  |     |
 * |------------------------------------------------------------|
 * |    |    |    |        PLAY            |     |LEFT|DWN|RIGHT|
 * `------------------------------------------------------------'
 */
```