###Keymaps with both Dvorak layout and QWER layout for HHKB JP.  

1. The default layout is Dvorak.
2. Use `Tog` to toggle between Dvorak and QWER
3. Holding `NewCmd`, the original `LftCmd`,  will activate the `NewCmd` layer which means `NewCmd+key` is the same as `Cmd+key` in normal QWER layout.<sup>[1](#cmdTab)</sup>
  - For example, no matter you are in Dvorak layout or QWER layout, you can use `Cmd+s` to save a currently editing file.
4. `Symb` makes type symbols easier
  - for example: `Symb+a` is `!`.
5. `Spc+key` equals to `Shft+key` while using `Spc` alone will yield a space as usual.
6. There's an extra `Tab` in the last line.
    
```
Layer DVOR:
,-----------------------------------------------------------.
|Esc|  1|  2|  3|  4|  5|  6|  7|  8|  9|  0|  -|  =|   |Bsp|
|-----------------------------------------------------------|
|Tab  |  '|   ,|  .|  P|  Y|  F|  G|  C|  R|  L|  /|  =|    |
|------------------------------------------------------` Ent|
|Ctrl  |  A|  O|  E|  U|  I|  D|  H|  T|  N|  S|  -|  \|    |
|-----------------------------------------------------------|
|Shft   |  ;|  Q|  J|  K|  X|  B|  M| W|  V|  Z|   | Up|    |
|-----------------------------------------------------------|
|FN| `| Alt|NewCmd|Symb|  Spc |Symb|Tab|RCmd|Tog|Lft|Dwn|Rgh|
`-----------------------------------------------------------'
```

```
Layer QWER:
,-----------------------------------------------------------.
|Esc|  1|  2|  3|  4|  5|  6|  7|  8|  9| 10|  -|  =|   |Bsp|
|-----------------------------------------------------------|
|Tab  |  Q|  W|  E|  R|  T|  Y|  U|  I|  O|  P|  [|  ]|     |
|------------------------------------------------------` Ent|
|Ctrl  |  A|  S|  D|  F|  G|  H|  J|  K|  L|  ;|  '|  \|    |
|-----------------------------------------------------------|
|Shft   |  Z|  X|  C|  V|  B|  N|  M|  ,|  .|  /|   | Up|   |
|-----------------------------------------------------------|
|FN| `| Alt|NewCmd|Symb|  Spc  |Symb|Tab|Cmd|Tog|Lft|Dwn|Rgh|
`-----------------------------------------------------------'
```

```
Layer Symb:
,-----------------------------------------------------------.
|   |   |   |   |   |   |   |   |   |   |  |   |   |   |    |
|-----------------------------------------------------------|
|     |   |   |   [|   ]|   |   |  {|  }|   |   |   |   |   |
|------------------------------------------------------`    |
|      |  !|  @|  #|  $|  %|  ^|  &|  *|  (|  )|  '|  \|    |
|-----------------------------------------------------------|
|       |   |   |   |   |   |   |   |   |   |   |   |   |   |
|-----------------------------------------------------------|
|  |  |    |      |    |       |    |   |   |   |   |   |   |
`-----------------------------------------------------------'
```

```
Layer FUNC: HHKB mode (HHKB Fn)
,-----------------------------------------------------------.
|Pwr| F1| F2| F3| F4| F5| F6| F7| F8| F9|F10|F11|F12|Ins|Del|
|-----------------------------------------------------------|
|Caps |   |   |   |   |   |   |   |Psc|Slk|Pus|Up |   |     |
|------------------------------------------------------`    |
|      |VoD|VoU|Mut|   |   |  *|  /|Hom|PgU|Lef|Rig|   |    |
|-----------------------------------------------------------|
|       |   |   |   |   |   |  +|  -|End|PgD|Dow|   |   |   |
|-----------------------------------------------------------|
|   ||   |   |   |   |         |   |   |   |   ||   |   |   |
`-----------------------------------------------------------'
```

```
Empty Layer:
,-----------------------------------------------------------.
|   |   |   |   |   |   |   |   |   |   |  |   |   |   |    |
|-----------------------------------------------------------|
|     |   |   |   |   |   |   |   |   |   |   |   |   |     |
|------------------------------------------------------`    |
|      |   |   |   |   |   |   |   |   |   |   |   |   |    |
|-----------------------------------------------------------|
|       |   |   |   |   |   |   |   |   |   |   |   |   |   |
|-----------------------------------------------------------|
|  |  |    |      |    |       |    |   |   |   |   |   |   |
`-----------------------------------------------------------'
```
<a name="cmdTab">1</a>: `NewCmd + Tab` does not work, you can use `RCmd+Tab` to switch among applications.
