# Nyquist Layout - rev 02

Standard qwerty layout.  
Limited emoji support and proper mouse settings.

Mostly based off of my XD75 layout.

## Keymap

```

/* Base
 * ,-----------------------------------------. ,-----------------------------------------.
 * | GEsc |   1  |   2  |   3  |   4  |   5  | |   6  |   7  |   8  |   9  |   0  | Bksp |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Tab  |   Q  |   W  |   E  |   R  |   T  | |   Y  |   U  |   I  |   O  |   P  | Entr |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | LOW  |   A  |   S  |   D  |   F  |   G  | |   H  |   J  |   K  |   L  |   ;  |  "   |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Shft |   Z  |   X  |   C  |   V  |   B  | |   N  |   M  |   ,  |   .  |   /  | Shft |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Ctrl | EMO  | Alt  | GUI  | SPCE |SP_LMS| |SP_RMS|SP_RMS| GUI  | Alt  | RAI  | Ctrl |
 * `-----------------------------------------' `-----------------------------------------'
 */


 /* Lower
 * ,-----------------------------------------. ,-----------------------------------------.
 * | GESC |   !  |   @  |   #  |   $  |   %  | |   ^  |   &  |   *  |   (  |   )  | Bksp |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Tab  |   !  |   @  |   #  |   $  |   %  | |   ^  |   &  |   *  |   (  |   )  | Entr |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * |      |  \   |  -   |  =   |  [   |  ]   | |  [   |  ]   |  -   |  =   |  \   | Del  |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Shft |  ^Z  |  ^X  |  ^C  |  ^V  |      | | Play | Vol+ | Vol- | Mute | Next | Shft |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Ctrl |      | Alt  | GUI  |      |      | |      |      | GUI  | Alt  |      | Ctrl |
 * `-----------------------------------------' `-----------------------------------------'
 */


/* Raise
 * ,-----------------------------------------. .-----------------------------------------.
 * | GESC |      |      |      |      |      | |      |   =  |   /  |   *  |   -  | Bksp  |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Tab  |  F9  |  F10 | F11  | F12  |      | |      |   7  |   8  |   9  |   +  | Entr |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * |      |  F5  |  F6  |  F7  |  F8  |      | |      |   4  |   5  |   6  |  ,   | Del  |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Shft |  F1  |  F2  |  F3  |  F4  |      | |      |   1  |   2  |   3  |  .   | Shft |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Ctrl |      | Alt  | GUI  |      |      | |      |  0   | GUI  | Alt  |      | Ctrl |
 * `-----------------------------------------' `-----------------------------------------'
 */


/* LMOUSE (Lower + Raise)
 * ,-----------------------------------------. ,-----------------------------------------.
 * | GESC |      | Home | End  | PGUP | PGDN | |      |      |      |      |      | Bksp |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Tab  | WH_L | BTN1 | MS_U | BTN2 | WH_U | |      |      |      |      |      | Entr |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * |      | WH_R | MS_L | MS_D | MS_R | WH_D | |      |      |      |      |      | Del  |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Shft | LEFT | DOWN |  UP  |RIGHT |      | |      |      |      |      |      | Shft |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Ctrl |      | Alt  | GUI  |      |      | |      |      | GUI  | Alt  |      | Ctrl |
 * `-----------------------------------------' `-----------------------------------------'
 */


/* RMOUSE (Lower + Raise)
 * ,-----------------------------------------. ,-----------------------------------------.
 * | GESC |      |      |      |      |      | | PGUP | PGDN | Home | End  |      | Bksp |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Tab  |      |      |      |      |      | | WH_U | BTN1 | MS_U | BTN2 | WH_L | Entr |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * |      |      |      |      |      |      | | WH_D | MS_L | MS_D | MS_R | WH_R | Del  |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Shft |      |      |      |      |      | |      | LEFT | DOWN |  UP  |RIGHT | Shft |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Ctrl |      | Alt  | GUI  |      |      | |      |      | GUI  | Alt  |      | Ctrl |
 * `-----------------------------------------' `-----------------------------------------'
 */


/* Emojis
 * ,-----------------------------------------. ,-----------------------------------------.
 * | GESC |      |      |      |      |      | | RSET |      |      |      |      | Bksp |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Tab  | CLAP | CUM  | BNIS | BUTT | CAR  | | FIRE | REDB | MONY | 100  | SOS | Entr |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * |      | CELE | PRAY | NAIL |  OK  | THNK | | UNAM | HEYE | COOL | EYES | SMIR | Del  |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Shft | TRIU | SCRM | VOMI | DTIV | EXPL | | HAIR | DANC | STRN | LEFT | RGHT | Shft |
 * |------+------+------+------+------+------| |------+------+------+------+------+------|
 * | Ctrl |      | Alt  | GUI  |      |      | |      |      | GUI  | Alt  |      | Ctrl |
 * `-----------------------------------------' `-----------------------------------------'
 */
```