# George Petri's Nyquist layout

```
sudo make keebio/nyquist/rev2:georgepetri:dfu
```

Features a dedicated navigation layer on rise and current layer status on rgb underglow.  

### Base Layer
```
┌──────┬──────┬──────┬──────┬──────┬──────┐ ┌──────┬──────┬──────┬──────┬──────┬──────┐
│ GRAVE│  1   │  2   │  3   │  4   │  5   │ │  6   │  7   │  8   │  9   │  0   │ BSPC │
├──────┼──────┼──────┼──────┼──────┼──────┤ ├──────┼──────┼──────┼──────┼──────┼──────┤
│  TAB │  Q   │  W   │  E   │  R   │  T   │ │  Y   │  U   │  I   │  O   │  P   │ DEL  │
├──────┼──────┼──────┼──────┼──────┼──────┤ ├──────┼──────┼──────┼──────┼──────┼──────┤
│  ESC │  A   │  S   │  D   │  F   │  G   │ │  H   │  J   │  K   │  L   │  SCLN│ QUOT │
├──────┼──────┼──────┼──────┼──────┼──────┤ ├──────┼──────┼──────┼──────┼──────┼──────┤
│  LSFT│  Z   │  X   │  C   │  V   │  B   │ │  N   │  M   │  COMM│  DOT │  SLSH│ ENT  │
├──────┼──────┼──────┼──────┼──────┼──────┤ ├──────┼──────┼──────┼──────┼──────┼──────┤
│  CAPS│  LCTL│ LGUI │ LALT │MO(_L)│  SPC │ │  RSFT│MO(_R)│  LEFT│  DOWN│  UP  │ RGHT │
└──────┴──────┴──────┴──────┴──────┴──────┘ └──────┴──────┴──────┴──────┴──────┴──────┘
```

### Lower
```
┌──────┬──────┬──────┬──────┬──────┬──────┐ ┌──────┬──────┬──────┬──────┬──────┬──────┐
│      │  F1  │  F2  │  F3  │  F4  │  F5  │ │  F6  │  F7  │  F8  │  F9  │  F10 │      │
├──────┼──────┼──────┼──────┼──────┼──────┤ ├──────┼──────┼──────┼──────┼──────┼──────┤
│      │  F11 │  F12 │      │      │      │ │      │  MINS│  EQL │  LBRC│  RBRC│ BSLS │
├──────┼──────┼──────┼──────┼──────┼──────┤ ├──────┼──────┼──────┼──────┼──────┼──────┤
│      │      │      │      │      │      │ │  LEFT│  DOWN│  UP  │  RGHT│      │      │
├──────┼──────┼──────┼──────┼──────┼──────┤ ├──────┼──────┼──────┼──────┼──────┼──────┤
│      │      │      │      │      │      │ │      │  PGDN│ PGUP │  HOME│  END │      │
├──────┼──────┼──────┼──────┼──────┼──────┤ ├──────┼──────┼──────┼──────┼──────┼──────┤
│      │      │      │      │      │      │ │      │      │      │      │      │      │
└──────┴──────┴──────┴──────┴──────┴──────┘ └──────┴──────┴──────┴──────┴──────┴──────┘
```

### Rise
```
┌──────┬──────┬──────┬──────┬──────┬──────┐ ┌──────┬──────┬──────┬──────┬──────┬──────┐
│      │      │      │      │      │      │ │      │      │      │      │      │      │
├──────┼──────┼──────┼──────┼──────┼──────┤ ├──────┼──────┼──────┼──────┼──────┼──────┤
│      │ TAB_L│ TAB_R│ TAB_C│ TAB_R│      │ │      │ TAB_L│ TAB_R│ TAB_C│ TAB_R│      │
├──────┼──────┼──────┼──────┼──────┼──────┤ ├──────┼──────┼──────┼──────┼──────┼──────┤
│      │  LEFT│  DOWN│  UP  │  RGHT│      │ │  LEFT│  DOWN│  UP  │  RGHT│      │      │
├──────┼──────┼──────┼──────┼──────┼──────┤ ├──────┼──────┼──────┼──────┼──────┼──────┤
│      │  PGDN│  PGUP│  HOME│  END │      │ │      │  PGDN│  PGUP│  HOME│  END │      │
├──────┼──────┼──────┼──────┼──────┼──────┤ ├──────┼──────┼──────┼──────┼──────┼──────┤
│      │      │      │      │      │      │ │      │      │      │      │      │      │
└──────┴──────┴──────┴──────┴──────┴──────┘ └──────┴──────┴──────┴──────┴──────┴──────┘
```
