# George Petri's Quefrency 65 layout

```
make keebio/quefrency/rev1:georgepetri
```

Querty layout with minor changes and dedicated navigation layer.

### Base Layer
```
┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐        ┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐
│  GRV ││  1   ││  2   ││  3   ││  4   ││  5   ││  6   │        │  7   ││  8   ││  9   ││  0   ││  BSPC││  DEL ││  MINS││  EQL ││  HOME│
└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘        └──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘
┌──────────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐        ┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────────┐┌──────┐
│  TAB     ││  Q   ││  W   ││  E   ││  R   ││  T   │        │  Y   ││  U   ││  I   ││  O   ││  P   ││  LBRC││  RBRC││  BSLS    ││  END │
└──────────┘└──────┘└──────┘└──────┘└──────┘└──────┘        └──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────────┘└──────┘
┌────────────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐        ┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌────────────────┐┌──────┐
│  ESC       ││  A   ││  S   ││  D   ││  F   ││  G   │        │  H   ││  J   ││  K   ││  L   ││  SCLN││  QUOT││  ENT           ││  PGUP│
└────────────┘└──────┘└──────┘└──────┘└──────┘└──────┘        └──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└────────────────┘└──────┘
┌────────────────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐        ┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌────────────────────┐┌──────┐
│  LSFT          ││  Z   ││  X   ││  C   ││  V   ││  B   │        │  N   ││  M   ││  COMM││  DOT ││  SLSH││  RSFT              ││  PGDN│
└────────────────┘└──────┘└──────┘└──────┘└──────┘└──────┘        └──────┘└──────┘└──────┘└──────┘└──────┘└────────────────────┘└──────┘
┌────────┐┌────────┐┌────────┐┌────────┐┌────────────────┐        ┌────────────────────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐
│  CAPS  ││  LCTL  ││  LALT  ││MO(_L)  ││  SPC           │        │  SPC               ││  LGUI││TG(_R)││  LEFT││  DOWN││  UP  ││  RGHT│
└────────┘└────────┘└────────┘└────────┘└────────────────┘        └────────────────────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘
```

### Raise
```
┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐        ┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐
│      ││  F1  ││  F2  ││  F3  ││  F4  ││  F5  ││  F6  │        │  F7  ││  F8  ││  F9  ││  F10 ││  F11 ││  F12 ││  BSPC││  DEL ││  INS │
└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘        └──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘
┌──────────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐        ┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────────┐┌──────┐
│          ││  F1  ││  F12 ││      ││      ││      │        │      ││  MINS││  EQL ││      ││      ││      ││      ││          ││  PAUS│
└──────────┘└──────┘└──────┘└──────┘└──────┘└──────┘        └──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────────┘└──────┘
┌────────────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐        ┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌────────────────┐┌──────┐
│            ││      ││      ││      ││      ││      │        │  LEFT││  DOWN││  UP  ││  RGHT││      ││      ││                ││      │
└────────────┘└──────┘└──────┘└──────┘└──────┘└──────┘        └──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└────────────────┘└──────┘
┌────────────────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐        ┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌────────────────────┐┌──────┐
│                ││      ││      ││      ││      ││      │        │      ││  PGDN││  PGUP││  HOME││  END ││                    ││      │
└────────────────┘└──────┘└──────┘└──────┘└──────┘└──────┘        └──────┘└──────┘└──────┘└──────┘└──────┘└────────────────────┘└──────┘
┌────────┐┌────────┐┌────────┐┌────────┐┌────────────────┐        ┌────────────────────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐
│        ││        ││        ││        ││                │        │                    ││      ││      ││      ││      ││      ││      │
└────────┘└────────┘└────────┘└────────┘└────────────────┘        └────────────────────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘
```

### Lower
```
┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐        ┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐
│      ││      ││      ││      ││      ││      ││      │        │      ││      ││      ││      ││      ││      ││      ││      ││      │
└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘        └──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘
┌──────────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐        ┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────────┐┌──────┐
│          ││ TAB_L││ TAB_R││ TAB_C││ TAB_R││      │        │      ││ TAB_L││ TAB_R││ TAB_C││ TAB_R││      ││      ││          ││      │
└──────────┘└──────┘└──────┘└──────┘└──────┘└──────┘        └──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────────┘└──────┘
┌────────────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐        ┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌────────────────┐┌──────┐
│            ││  LEFT││  DOWN││  UP  ││  RGHT││      │        │  LEFT││  DOWN││  UP  ││  RGHT││      ││      ││                ││      │
└────────────┘└──────┘└──────┘└──────┘└──────┘└──────┘        └──────┘└──────┘└──────┘└──────┘└──────┘└──────┘└────────────────┘└──────┘
┌────────────────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐        ┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌────────────────────┐┌──────┐
│                ││  PGDN││  PGUP││  HOME││  END ││      │        │      ││  PGDN││  PGUP││  HOME││  END ││                    ││      │
└────────────────┘└──────┘└──────┘└──────┘└──────┘└──────┘        └──────┘└──────┘└──────┘└──────┘└──────┘└────────────────────┘└──────┘
┌────────┐┌────────┐┌────────┐┌────────┐┌────────────────┐        ┌────────────────────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐┌──────┐
│        ││        ││        ││        ││                │        │                    ││      ││      ││      ││      ││      ││      │
└────────┘└────────┘└────────┘└────────┘└────────────────┘        └────────────────────┘└──────┘└──────┘└──────┘└──────┘└──────┘└──────┘
```
