# Xyverz's Keyboardio Atreus Keymap

## About this keymap:

This is the first iteration of my Keyboardio Atreus keymap. This is entirely based on my original Atreus keymap
with a few changes added to reflect the extra two keys, and a code update to current standards.

I'm using MOD_TAP quite a bit in this keymap. On all layers, R4 pinky keys use mod-tap and are SHIFT when held
and their normal keys when tapped. In addition, ESC and TAB are also set as Ctrl and ALT respectively when held,
and Enter/ALT on the right thumb key for all alpha layers.

I've enabled persistent keymaps for Qwerty, Dvorak and Colemak layers, similar to the default Planck layouts.

Recently added: Documentation, Formatting, and another Dvorak layer that has Command on the left thumb, instead of
Control.

## Still to do:

 * Enjoy this revision; figure out new things later.

### Layer 0: Dvorak layer

	,----------------------------------.              ,----------------------------------.
	|   '  |   ,  |   .  |   P  |   Y  |              |   F  |   G  |   C  |   R  |   L  |
	|------+------+------+------+------|              |------+------+------+------+------|
	|   A  |   O  |   E  |   U  |   I  |              |   D  |   H  |   T  |   N  |   S  |
	|------+------+------+------+------+------.,------+------+------+------+------+------|
	|SFT/ ;|   Q  |   J  |   K  |   X  | Home || End  |   B  |   M  |   W  |   V  |SFT/ Z|
	|------+------+------+------+------+------||------+------+------+------+------+------|
	|  Esc |  Tab |  GUI | LOWER| BkSp | LCTL ||ALTENT|  Spc | RAISE|   -  |   /  |   \  |
	`-----------------------------------------'`-----------------------------------------'

### Layer 1: QWERTY layer

	,----------------------------------.              ,----------------------------------.
	|   Q  |   W  |   E  |   R  |   T  |              |   Y  |   U  |   I  |   O  |   P  |
	|------+------+------+------+------|              |------+------+------+------+------|
	|   A  |   S  |   D  |   F  |   G  |              |   H  |   J  |   K  |   L  |   ;  |
	|------+------+------+------+------+------.,------+------+------+------+------+------|
	|SFT/ Z|   X  |   C  |   V  |   B  | Home || End  |   N  |   M  |   ,  |   .  |SFT/ /|
	|------+------+------+------+------+------||------+------+------+------+------+------|
	|  Esc |  Tab |  GUI | LOWER| BkSp | LCTL ||ALTENT|  Spc | RAISE|   -  |   '  |   \  |
	`-----------------------------------------'`-----------------------------------------'
	 
### Layer 2: Colemak layer

	,----------------------------------.              ,----------------------------------.
	|   Q  |   W  |   F  |   P  |   G  |              |   J  |   L  |   U  |   Y  |   L  |
	|------+------+------+------+------|              |------+------+------+------+------|
	|   A  |   R  |   S  |   T  |   D  |              |   H  |   N  |   E  |   I  |   S  |
	|------+------+------+------+------+------.,------+------+------+------+------+------|
	|SFT/ Z|   X  |   C  |   V  |   B  | Home || End  |   K  |   M  |   ,  |   .  |SFT/ /|
	|------+------+------+------+------+------||------+------+------+------+------+------|
	|  Esc |  Tab |  GUI | LOWER| BkSp | LCTL ||ALTENT|  Spc | RAISE|   -  |   '  |   \  |
	`-----------------------------------------'`-----------------------------------------'

### Layer 3: Dvorak for Mac layer

	,----------------------------------.              ,----------------------------------.
	|   '  |   ,  |   .  |   P  |   Y  |              |   F  |   G  |   C  |   R  |   L  |
	|------+------+------+------+------|              |------+------+------+------+------|
	|   A  |   O  |   E  |   U  |   I  |              |   D  |   H  |   T  |   N  |   S  |
	|------+------+------+------+------+------.,------+------+------+------+------+------|
	|SFT/ ;|   Q  |   J  |   K  |   X  | Home || End  |   B  |   M  |   W  |   V  |SFT/ Z|
	|------+------+------+------+------+------||------+------+------+------+------+------|
	|  Esc |  Tab |  GUI | LOWER| BkSp | LGUI ||ALTENT|  Spc | RAISE|   -  |   /  |   \  |
	`-----------------------------------------'`-----------------------------------------'

### Layer 4: LOWER layer

	,----------------------------------.              ,----------------------------------.
	|   !  |   @  |   #  |   $  |   %  |              |   ^  |   &  |   *  |   (  |   )  |
	|------+------+------+------+------|              |------+------+------+------+------|
	| CAPS |      |  UP  |      | Home |              | PgDn |      |   +  |   {  |   }  |
	|------+------+------+------+------+------.,------+------+------+------+------+------|
	|      | Left | Down | Right| End  |      ||      | PgUp | Mute | Vol- | Vol+ |      |
	|------+------+------+------+------+------||------+------+------+------+------+------|
	|   ~  |      |      |      | Del  |      ||      | Ins  |      |      |      |      |
	`-----------------------------------------'`-----------------------------------------'


### Layer 5: RAISE layer

	,----------------------------------.              ,----------------------------------.
	|   1  |   2  |   3  |   4  |   5  |              |   6  |   7  |   8  |   9  |   0  |
	|------+------+------+------+------|              |------+------+------+------+------|
	| CAPS |      |  UP  |      | Home |              | PgDn |      |   =  |   [  |   ]  |
	|------+------+------+------+------+------.,------+------+------+------+------+------|
	|      | Left | Down | Right| End  |MacLck||      | PgUp | Prev | Play | Next |      |
	|------+------+------+------+------+------||------+------+------+------+------+------|
	|   `  |      |      |      | Del  |      ||      | Ins  |      |      |      |      |
	`-----------------------------------------'`-----------------------------------------'

### Layer 6: ADJUST layer

	,----------------------------------.              ,----------------------------------.
	|  F1  |  F2  |  F3  |  F4  |  F5  |              |  F6  |  F7  |  F8  |  F9  | F10  |
	|------+------+------+------+------|              |------+------+------+------+------|
	|  F11 |      |      |      |      |              |      | PrSc | ScLk | Paus | F12  |
	|------+------+------+------+------+------.,------+------+------+------+------+------|
	|      |QWERTY|COLEMK|DVORAK|DVORMC|      ||      |      |      |      |      |      |
	|------+------+------+------+------+------||------+------+------+------+------+------|
	|      |      |      |      |      |      ||      |      |      |      |      | RESET|
	`-----------------------------------------'`-----------------------------------------'

