# Keymap for the winkeyless version of KMAC

This is the default keymap for the winkeyless version of the PCB. It implements the same features as the official default KMAC firmware.

## Layers

The keymap have two layers. To access the functions on the second layer, hold down `Fn` and press the corresponding key.

### Layer 1: Default Layer
     ,---.   ,---------------. ,---------------. ,---------------. ,-----------.
     |Esc|   |F1 |F2 |F3 |F4 | |F5 |F6 |F7 |F8 | |F9 |F10|F11|F12| |PrS|ScL|Pau|
     `---'   `---------------' `---------------' `---------------' `-----------'
     ,-----------------------------------------------------------. ,-----------.
     |~  |  1|  2|  3|  4|  5|  6|  7|  8|  9|  0|  -|  =|Backsp | |Ins|Hom|PgU|
     |-----------------------------------------------------------| |-----------|
     |Tab  |  Q|  W|  E|  R|  T|  Y|  U|  I|  O|  P|  [|  ]|    \| |Del|End|PgD|
     |-----------------------------------------------------------| '-----------'
     |Caps  |  A|  S|  D|  F|  G|  H|  J|  K|  L|  ;|  '|Return  |
     |-----------------------------------------------------------|     ,---.
     |Shift   |  Z|  X|  C|  V|  B|  N|  M|  ,|  .|  /|Shift     |     |Up |
     |-----------------------------------------------------------| ,-----------.
     |Ctl |   |Alt |              Space            |Fn  |   |Ctl | |Lef|Dow|Rig|
     `----'   `-----------------------------------------'   `----' `-----------'

### Layer 2: Function Layer
     ,---.   ,---------------. ,---------------. ,---------------. ,-----------.
     |Led|   |M1 |M2 |M3 |M4 | |M5 |M6 |M7 |M8 | |M9 |M10|M11|M12| |   |   |   |
     `---'   `---------------' `---------------' `---------------' `-----------'
     ,-----------------------------------------------------------. ,-----------.
     |   |   |   |   |   |   |   |   |   |   |   |   |   |       | |   |   |   |
     |-----------------------------------------------------------| |-----------|
     |     |   |   |   |   |   |   |   |   |   |   |   |   |     | |   |   |   |
     |-----------------------------------------------------------| '-----------'
     |      |   |   |   |   |   |   |   |   |   |   |   |        |
     |-----------------------------------------------------------|     ,---.
     |        |   |   |   |   |   |   |   |   |   |   |          |     |   |
     |-----------------------------------------------------------| ,-----------.
     |    |   |    |                               |    |   |    | |   |   |   |
     `----'   `-----------------------------------------'   `----' `-----------'

## Macros

These are mostly useless and serve more like examples I guess.

| Macro | Action                                 |
|:-----:| -------------------------------------- |
| 1     | Types `The`                            |
| 2     | Types `Custom`                         |
| 3     | Types `Keyboard`                       |
| 4     | Inputs `<Ctrl+c>` `<Right>` `<Ctrl+v>` |
