# The default keymap for KMAC PAD

This is the default keymap. It implements the same features as the official default KMAC PAD firmware.

## Layers

The keymap has two layers. Press the 'FN' key to toggle the Default layer and Function layer.

### Layer 1: Default Layer

                ,---.
                |TG1|
                `---'
    ,---------------.
    |NUM| / | * | - |
    |---------------|
    | 7 | 8 | 9 |   |
    |-----------| + |
    | 4 | 5 | 6 |   |
    |---------------|
    | 1 | 2 | 3 |   |
    |-----------|Ent|
    |   0   | . |   |
    '---------------'

### Layer 2: Function Layer

                ,---.
                |TG1|
                `---'
    ,---------------.
    |M1 |M2 |M3 |   |
    |---------------|
    |M4 |M5 |M6 |   |
    |-----------|   |
    |M7 |M8 |M9 |   |
    |---------------|
    |M10|M11|M12|   |
    |-----------|   |
    |       |   |   |
    '---------------'

## Macros

The default macro is typed with meaningless strings that exist as samples.


| Macro | Action                                 |
|:-----:| -------------------------------------- |
| 1     | Types `Macro 1`                        |
| 2     | Types `Macro 2`                        |
| 3     | Types `Macro 3`                        |
| 4     | Types `Macro 4`                        |
| 5     | Types `Macro 5`                        |
| 6     | Types `Macro 6`                        |
| 7     | Types `Macro 7`                        |
| 8     | Types `Macro 8`                        |
| 9     | Types `Macro 9`                        |
| 10    | Types `Macro 10`                       |
| 11    | Types `Macro 11`                       |
| 12    | Types `Macro 12`                       |
