```
/* Base layer - workman
 *
 * ,----------------------------------.           ,----------------------------------.
 * |   q  |   d  |   r  |   w  |   b  |           |   j  |   f  |   u  |   p  |   ;  |
 * |------+------+------+------+------|           |------+------+------+------+------|
 * |   a  |   s  |   h  |   t  |   g  |           |   y  |   n  |   e  |   o  |   i  |
 * |------+------+------+------+------|           |------+------+------+------+------|
 * |   z  |   x  |   m  |   c  |   v  |           |   k  |   l  | dead |   .  |   /  |
 * `----------------------------------'           `----------------------------------'
 *                  ,--------------------.    ,---------------------.
 *                 | tab   | esc  | enter|    |bckspc| space|   tab |
 *                 | shift | ctrl | alt  |    |  gui |   fn | shift |
 *                 `-------+------+      |    |      |------+-------.
 *                                `------'    `------'
 */

/* Dead key layer
 *
 * ,----------------------------------.           ,----------------------------------.
 * |   %  |   &  |   ?  |   +  |   @  |           |   $  |   _  |   [  |   ]  |   !  |
 * |------+------+------+------+------|           |------+------+------+------+------|
 * |   #  |   (  |   =  |   0  |   {  |           |   }  |   1  |   *  |   )  |   -  |
 * |------+------+------+------+------|           |------+------+------+------+------|
 * |   6  |   7  |   8  |   9  |   |  |           |   \  |   2  |   3  |   4  |   5  |
 * `----------------------------------'           `----------------------------------'
 *                  ,--------------------.    ,---------------------.
 *                 | tab   | esc  | comma|    |bckspc| comma|   tab |
 *                 | shift | ctrl |+enter|    |  gui |+space| shift |
 *                 `-------+------+      |    |      |------+-------.
 *                                `------'    `------'
 */

/* Function layer
 *
 * ,----------------------------------.           ,---------------------------------.
 * |      |  del |⌃←  |  ⌃→ |      |           | mute | vol- | vol+ | ⌘⌃p |      |
 * |------+------+------+------+------|           |------+------+------+------+------|
 * |   `  |  end | pgup | pgdn | home |           |  ←  |   ↓  |   ↑  |  →  |   '  |
 * |------+------+------+------+------|           |------+------+------+------+------|
 * | ⌥⇥ |      |⇧⌃⇥| ⌃⇥  |       |           |      |  br- | ,    | br+  |  ^   |
 * `----------------------------------'           `----------------------------------'
 *                  ,--------------------.    ,---------------------.
 *                 | tab   |      | enter|    |bckspc|      |   tab |
 *                 | shift |      | alt  |    |  gui |      | shift |
 *                 `-------+------+      |    |      |------+-------.
 *                                `------'    `------'
 */
```
