# Semi-wide German/English MIT Planck Layout
Added keymap for my planck MIT.
It has a German and an English switching mode, so that it works the exact same with both OS languages.
It is a semi-wide layout, with the left hand all the way to the edge, and with one extra column in the middle used for media controls.
Home row mods implemented in the top row with individual tapping_terms for different fingers.
Mouse layer accessible through the pinkies.
Navigation layer on space.

```
/* _HRWIDECOLEMAK
* ,-----------------------------------------------------------------------------------.
* |  G-Q |  A-W |  S-F |  C-P |_Num-B|Vol/B+|_Num-J|  C-L |  S-U |  A-Y |  G-/ |   ü  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |   A  |   R  |   S  |   T  |   G  | TAB  |   M  |   N  |   E  |   I  |   O  |   '  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |_Mo-Z |   X  |   C  |   D  |   V  |Vol/B-|   K  |   H  |   ,  |   .  |_Mo-/ |   \  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |C-CAPS| LEAD |MN-ESC|_L-BSP| LSFT |  _Nav-SPC   |_R-ENT|S-DEL | RALT |_Mo <-|_Mo ->|
* `-----------------------------------------------------------------------------------'
*/
/* _HRWIDECOLEMAK_DE
* same as above, when the PC is set to German layout
* ,-----------------------------------------------------------------------------------.
* |  G-Q |  A-W |  S-F |  C-P |_Num-B|Vol/B+|_Num-J|  C-L |  S-U |  A-Y |  G-/ |   ü  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |   A  |   R  |   S  |   T  |   G  | TAB  |   M  |   N  |   E  |   I  |   O  |   '  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |_Mo-Z |   X  |   C  |   D  |   V  |Vol/B-|   K  |   H  |   ,  |   .  |_Mo-/ |   \  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |C-CAPS| LEAD |MN-ESC|_L-BSP| LSFT |  _Nav-SPC   |_R-ENT|S-DEL | RALT |_Mo <-|_Mo ->|
* `-----------------------------------------------------------------------------------'
*/
/* _GAMING
* ,-----------------------------------------------------------------------------------.
* | ESC  |   1  |   2  |   3  |   4  |   5  |   6  |   7  |  F5  |  F8  |  F9  |Vol/B+|
* |------+------+------+------+------+------+------+------+------+------+------+------|
* | TAB  |   Q  |   W  |   E  |   R  |   T  |   Y  |   U  |   I  |   O  |   P  |Vol/B-|
* |------+------+------+------+------+------+------+------+------+------+------+------|
* | LSFT |   A  |   S  |   D  |   F  |   G  |   H  |   J  |   Z  |   M  |   ;  |_CM-EN|
* |------+------+------+------+------+------+------+------+------+------+------+------|
* | LCTL |   C  |   B  |   X  | LALT |    SPACE    | ENT  | RALT | ____ | ____ | !GAME|
* `-----------------------------------------------------------------------------------'
*/
/* WIDECOLEMAK
* no mod taps
* ,-----------------------------------------------------------------------------------.
* |   Q  |   W  |   F  |   P  |   B  |Vol/B+|   J  |   L  |   U  |   Y  |   /  |   Ü  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |   A  |   R  |   S  |   T  |   G  | TAB  |   M  |   N  |   E  |   I  |   O  |   '  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |   Z  |   X  |   C  |   D  |   V  |Vol/B-|   K  |   H  |   ,  |   .  |   /  |!CM-EN|
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |C-CAPS|G-TAB |MN-ESC|_L-BSP| LSFT |  _NAV-SPC   |_R-ENT|S-DEL |C-TAB |_Mo <-|_Mo ->|
* `-----------------------------------------------------------------------------------'
*/
/* _LOWER
* ,-----------------------------------------------------------------------------------.
* |   !  |   @  |   #  |   $  |   %  |   ~  |   ^  |   &  |   *  |   (  |   )  |   Ö  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |   ß  |   _  |   +  |   {  |   }  |   Ä  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |  F7  |  F8  |  F9  |  F10 |  F11 |  F12 | MPLY |   /  |   \  |   |  |   €  |   è  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |!MOUSE| ____ | ____ | ____ | ____ |     ____    | ____ | Vol- | Vol+ |   ↓  |   ↑  |
* `-----------------------------------------------------------------------------------'
*/
/* _LOWER_DE
* ,-----------------------------------------------------------------------------------.
* |   !  |   @  |   #  |   $  |   %  |   ~  |   ^  |   &  |   *  |   (  |   )  |   Ö  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |   ß  |   _  |   +  |   {  |   }  |   Ä  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |  F7  |  F8  |  F9  |  F10 |  F11 |  F12 | MPLY |   /  |   \  |   |  |   €  |   `  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |!MOUSE| ____ | ____ | ____ | ____ |     ____    | ____ | Vol- | Vol+ |   ↓  |   ↑  |
* `-----------------------------------------------------------------------------------'
*/
/* _RAISE
* ,-----------------------------------------------------------------------------------.
* |   1  |   2  |   3  |   4  |   5  |   `  |   6  |   7  |   8  |   9  |   0  |   ö  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |   ß  |   -  |   =  |   [  |   ]  |   ä  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |  F7  |  F8  |  F9  |  F10 |  F11 |  F12 | MPLY |   \  |   ,  |   .  |   /  |   é  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |!MOUSE| ____ | ____ | BSPC | ____ |     ____    | ____ |  |<< | >>|  |   ↓  |   ↑  |
* `-----------------------------------------------------------------------------------'
*/
/* _RAISE_DE
* ,-----------------------------------------------------------------------------------.
* |   1  |   2  |   3  |   4  |   5  |   `  |   6  |   7  |   8  |   9  |   0  |   ö  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |   ß  |   -  |   =  |   [  |   ]  |   ä  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |  F7  |  F8  |  F9  |  F10 |  F11 |  F12 | MPLY |   \  |   ,  |   .  |   /  |   ´  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |!MOUSE| ____ | ____ | BSPC | ____ |     ____    | ____ |  |<< | >>|  |   ↓  |   ↑  |
* `-----------------------------------------------------------------------------------'
*/
/* _ADJUST
* ,-----------------------------------------------------------------------------------.
* | A-SFT| RESET| DEBUG|RGBTOG|RGBMOD|RGBHUI|RGBHUD|RGBSAI|RGBSAD|RGBVAI|RGBVAD| DE_SW|
* |------+------+------+------+------+------+------+------+------+------+------+------|
* | A-GRV|EEPRST|MU_MOD| AU_ON|AU_OFF|AGNORM|AGSWAP|!HRWCM| !WCM | A-GRV| !LANG| !GAME|
* |------+------+------+------+------+------+------+------+------+------+------+------|
* | ____ |MUV_DE|MUV_IN| MU_ON|MU_OFF| MI_ON|MI_OFF| Vol- | MPLY | Vol+ | ____ | ____ |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* | ____ | ____ | ____ | ____ | ____ |     ____    | ____ | ____ | ____ | ____ |EEPRST|
* `-----------------------------------------------------------------------------------'
*/
/* _NAV
* ,-----------------------------------------------------------------------------------.
* |A(TAB)| C(->)| !LANG|A(GRV)| C(<-)| >>|  | HOME |  ->  | PGUP | COPY | PASTE| DE_SW|
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |C(TAB)|  TAB |  ESC |  ENT |VIM_GG| MPLY |  <-  |   ↓  |   ↑  |  ->  |  END | VIM_O|  
* |------+------+------+------+------+------+------+------+------+------+------+------|
* | LSFT | XXXX |S(DEL)| CAPS | VIM_V| MUTE | HOME | PGDN | LSFT | RFST | C(F) | C(F) |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* | XXXX | XXXX | ____ | BSPC | ____ |     ____    |  ENT |  DEL | ____ | ____ | DE_SW|
* `-----------------------------------------------------------------------------------'
*/
/* _VIM
* ,-----------------------------------------------------------------------------------.
* |A(TAB)| C(->)| !LANG|A(GRV)| C(<-)| >>|  | HOME |  ->  | PGUP | COPY | PASTE| DE_SW|
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |C(TAB)|  TAB |  ESC |  ENT |VIM_GG| MPLY |  <-  |   ↓  |   ↑  |  ->  |  END | VIM_O|  
* |------+------+------+------+------+------+------+------+------+------+------+------|
* | LSFT | XXXX |S(DEL)| CAPS | VIM_V| MUTE | HOME | PGDN | LSFT | RFST | C(F) | C(F) |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* | XXXX | XXXX | !VIM | BSPC | ____ |     ____    |  ENT |  DEL | ____ |   ↓  |   ↑  |
* `-----------------------------------------------------------------------------------'
*/
/* _NUM
* ,-----------------------------------------------------------------------------------.
* |  F1  |  F2  |  F3  |  F4  |  |<< |NUMLCK| >>|  |   7  |   8  |   9  |   -  | ____ |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |  F5  |  F6  |  F7  |  F8  | Vol+ | MPLY |   *  |   4  |   5  |   6  |   +  |   .  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |  F9  |  F10 |  F11 |  F12 | Vol- | MUTE |   =  |   1  |   2  |   3  |   /  |   ,  |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* | ____ | ____ | ____ | ____ | ____ |     ____    |   0  |   .  |   ,  |   =  | ____ |
* `-----------------------------------------------------------------------------------'
*/
/* _MOUSE
* ,-----------------------------------------------------------------------------------.
* | XXXX | XXXX | MBTN4| MBTN5| XXXX | Bri+ | XXXX | MWHL↑|MAUS↑ | MWHL↑| XXXX | XXXX |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* | XXXX | MBTN3| MBTN2| MBTN1| XXXX | MPLY | XXXX |MAUS<-|MAUS↓ |MAUS->| XXXX | XXXX |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |  F9  | XXXX | XXXX | XXXX | XXXX | Bri- | XXXX | MWHL↓| XXXX | XXXX | ____ | XXXX |
* |------+------+------+------+------+------+------+------+------+------+------+------|
* |!MOUSE| XXXX | XXXX | ____ | XXXX | MAUS_ACCEL2 | ____ | XXXX | XXXX |   ↓  |   ↑  |
* `-----------------------------------------------------------------------------------'
 */
