# Preonic layout by [Blake Newman](https://github.com/blake-newman)

## Layouts

### Qwerty
```
,-----------------------------------------------------------------------------------.
|   `  |   1  |   2  |   3  |   4  |   5  |   6  |   7  |   8  |   9  |   0  | Del  |
|------+------+------+------+------+------+------+------+------+------+------+------|
| Tab  |   Q  |   W  |   E  |   R  |   T  |   Y  |   U  |   I  |   O  |   P  | Bksp |
|------+------+------+------+------+-------------+------+------+------+------+------|
| Bksp |   A  |   S  |   D  |   F  |   G  |   H  |   J  |   K  |   L  |   ;  |  "   |
|------+------+------+------+------+------|------+------+------+------+------+------|
| Shift|   Z  |   X  |   C  |   V  |   B  |   N  |   M  |   ,  |   .  |   /  | Shift|
|------+------+------+------+------+------+------+------+------+------+------+------|
| Brite| Ctrl | Alt  | GUI  |Lower |    Space    |Raise |      |  Alt | Ctrl | Shift|
`-----------------------------------------------------------------------------------'
```

### Colemak
```
,-----------------------------------------------------------------------------------.
|   `  |   1  |   2  |   3  |   4  |   5  |   6  |   7  |   8  |   9  |   0  | Del  |
|------+------+------+------+------+------+------+------+------+------+------+------|
| Tab  |   Q  |   W  |   F  |   P  |   G  |   J  |   L  |   U  |   Y  |   ;  | Bksp |
|------+------+------+------+------+-------------+------+------+------+------+------|
| Bksp |   A  |   R  |   S  |   T  |   D  |   H  |   N  |   E  |   I  |   O  |  "   |
|------+------+------+------+------+------|------+------+------+------+------+------|
| Shift|   Z  |   X  |   C  |   V  |   B  |   K  |   M  |   ,  |   .  |   /  | Shift|
|------+------+------+------+------+------+------+------+------+------+------+------|
| Brite| Ctrl | Alt  | GUI  |Lower |    Space    |Raise |      |  Alt | Ctrl | Shift|
`-----------------------------------------------------------------------------------'
```

### Dvorak
```
,-----------------------------------------------------------------------------------.
|   `  |   1  |   2  |   3  |   4  |   5  |   6  |   7  |   8  |   9  |   0  | Del  |
|------+------+------+------+------+------+------+------+------+------+------+------|
| Tab  |   "  |   ,  |   .  |   P  |   Y  |   F  |   G  |   C  |   R  |   L  | Bksp |
|------+------+------+------+------+-------------+------+------+------+------+------|
| Bksp |   A  |   O  |   E  |   U  |   I  |   D  |   H  |   T  |   N  |   S  |  /   |
|------+------+------+------+------+------|------+------+------+------+------+------|
| Shift|   ;  |   Q  |   J  |   K  |   X  |   B  |   M  |   W  |   V  |   Z  | Shift|
|------+------+------+------+------+------+------+------+------+------+------+------|
| Brite| Ctrl | Alt  | GUI  |Lower |    Space    |Raise |      |  Alt | Ctrl | Shift|
`-----------------------------------------------------------------------------------'
```

### Numpad
```
,-----------------------------------------------------------------------------------.
| Esc  |      |      | PgDn | PgUp | Home |  End  |      |   /  |   *  |   -  | Del  |
|------+------+------+------+------+------+------+------+------+------+------+------|
| Tab  |      |  Up  |      |      |      |      |   7  |   8  |   9  |   +  | Bksp |
|------+------+------+------+------+-------------+------+------+------+------+------|
| Bksp | Left | Down | Right|      |      |      |   4  |   5  |   6  |      |  "   |
|------+------+------+------+------+------|------+------+------+------+------+------|
| Shift|      |      |      |      |      |   ,  |   1  |   2  |   3  |      | Shift|
|------+------+------+------+------+------+------+------+------+------+------+------|
| Brite| Ctrl | Alt  | GUI  |Lower |    Space    |Raise |   0  |   .  | Ctrl | Shift|
`-----------------------------------------------------------------------------------'
```

### Lower
```
,-----------------------------------------------------------------------------------.
|  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |  F7  |  F8  |  F9  |  F10 |  F11 |  F12 |
|------+------+------+------+------+-------------+------+------+------+------+------|
|  Esc |      |  Up  |      |      |      |      |   -_ |   -  |   +  |   =  | Bksp |
|------+------+------+------+------+-------------+------+------+------+------+------|
|  Bksp| Left | Down | Right|      |      |      |   {  |   }  |   [  |   ]  |   \  |
|------+------+------+------+------+------|------+------+------+------+------+------|
| Shift|   |  |      |      |      |      |      |      |      |   ¢  |   €  | Shift|
|------+------+------+------+------+------+------+------+------+------+------+------|
| Brite| Ctrl | Alt  | GUI  |Lower |    Enter    |Raise |      |  Alt | Ctrl | Shift|
`-----------------------------------------------------------------------------------'
```

### Raise
```
,-----------------------------------------------------------------------------------.
|  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |  F7  |  F8  |  F9  |  F10 |  F11 |  F12 |
|------+------+------+------+------+-------------+------+------+------+------+------|
|  Esc |      |  Up  |      |      |      |      |   -  |   _  |   =  |   +  | Bksp |
|------+------+------+------+------+-------------+------+------+------+------+------|
| Bksp | Left | Down | Right|      |      |      |   [  |  ]   |   {  |   }  |   |  |
|------+------+------+------+------+------|------+------+------+------+------+------|
| Shift|  \   |      |      |      |      |      |      |      |   £  |  $   | Shift|
|------+------+------+------+------+------+------+------+------+------+------+------|
| Brite| Ctrl | Alt  | GUI  |Lower |    Enter    |Raise |      |  Alt | Ctrl | Shift|
`-----------------------------------------------------------------------------------'
```

### Adjust (Lower + Raise)
```
,-----------------------------------------------------------------------------------.
|      |      |      |      |      |      |      |      |      |      |      |      |
|------+------+------+------+------+------+------+------+------+------+------+------|
|      | Reset| Debug|      |      |      |      |      |      | aPscr| sPscr| Pscr |
|------+------+------+------+------+-------------+------+------+------+------+------|
| Caps |      |      |Aud on|AudOff|AGnorm|AGswap|Qwerty|Colemk|Dvorak|Numpad|Insert|
|------+------+------+------+------+------|------+------+------+------+------+------|
|      |Voice-|Voice+|Mus on|MusOff|MidiOn|MidOff|      |      |      |      |      |
|------+------+------+------+------+------+------+------+------+------+------+------|
|      |      |      |      |      |             |      | Next | Vol- | Vol+ | Play |
`-----------------------------------------------------------------------------------'
```
