# Choromanski

## Features
* Colemak
* Qwerty
* Toggable function row
* Symbol layer programmer friendly
* Numpad/Mouse layer with media controls

## Layers

### 0 Colemak
```
,-----------------------------------------------------------------------------------.
|  1 ` |   2  |   3  |   4  |   5  |   6  |   7  |   8  |   9  |   0  |   -  |  = \ |
|------+------+------+------+------+------+------+------+------+------+------+------|
| Tab  |   Q  |   W  |   F  |   P  |   G  |   J  |   L  |   U  |   Y  |   ;  |  [ ] |
|------+------+------+------+------+------+------+------+------+------+------+------|
| Esc  |   A  |   R  |   S  |   T  |   D  |   H  |   N  |   E  |   I  |   O  |  "   |
|------+------+------+------+------+------+------+------+------+------+------+------|
| Shift|   Z  |   X  |   C  |   V  |   B  |   K  |   M  |   ,  |   .  |   /  |Numpad|
|------+------+------+------+------+------+------+------+------+------+------+------|
|Symbol| Ctrl | Alt  | GUI  | Bksp | Del  |Enter |Space | Left | Down |  Up  |Right |
`-----------------------------------------------------------------------------------'
```
### 1 Qwerty
```
,-----------------------------------------------------------------------------------.
|  1 ` |   2  |   3  |   4  |   5  |   6  |   7  |   8  |   9  |   0  |   -  |  = \ |
|------+------+------+------+------+------+------+------+------+------+------+------|
| Tab  |   Q  |   W  |   E  |   R  |   T  |   Y  |   U  |   I  |   O  |   P  |  [ ] |
|------+------+------+------+------+------+------+------+------+------+------+------|
| Esc  |   A  |   S  |   D  |   F  |   G  |   H  |   J  |   K  |   L  |   ;  |  "   |
|------+------+------+------+------+------+------+------+------+------+------+------|
| Shift|   Z  |   X  |   C  |   V  |   B  |   N  |   M  |   ,  |   .  |   /  |Numpad|
|------+------+------+------+------+------+------+------+------+------+------+------|
|Symbol| Ctrl | Alt  | GUI  | Bksp | Del  |Enter |Space | Left | Down |  Up  |Right |
`-----------------------------------------------------------------------------------'
```
### 2 Function Lock
```
,-----------------------------------------------------------------------------------.
|  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |  F7  |  F8  |  F9  |  F10 |  F11 |  F12 |
|------+------+------+------+------+------+------+------+------+------+------+------|
|      |      |      |      |      |      |      |      |      |      |      |      |
|------+------+------+------+------+------+------+------+------+------+------+------|
|      |      |      |      |      |      |      |      |      |      |      |      |
|------+------+------+------+------+------+------+------+------+------+------+------|
|      |      |      |      |      |      |      |      |      |      |      |      |
|------+------+------+------+------+------+------+------+------+------+------+------|
|Symbol|      |      |      |      |      |      |      |      |      |      |      |
`-----------------------------------------------------------------------------------'
```
### 3 Numpad/Mouse with Media Controls
```
,-----------------------------------------------------------------------------------.
|   `  |      |      |M-clic|      |      |      |      |   /  |   |   -  |  \   |
|------+------+------+------+------+------+------+------+------+------+------+------|
|      | ACL0 |L-clck|  Up  |R-clck|Scrl U|      |   7  |   8  |   9  |   +  |  ]   |
|------+------+------+------+------+------+------+------+------+------+------+------|
|      | ACL1 | Left | Down |Right |Scrl D|      |   4  |   5  |   6  |   +  |      |
|------+------+------+------+------+------+------+------+------+------+------+------|
|      | ACL2 | VOLU | PREV |PAUSE | NEXT |      |   1  |   2  |   3  |Enter | Back |
|------+------+------+------+------+------+------+------+------+------+------+------|
|Symbol|      | VOLD | MUTE | Bksp | Del  |Enter |Space |   0  |   .  |Enter |      |
`-----------------------------------------------------------------------------------'
```
### 4 Symbols
```
,-----------------------------------------------------------------------------------.
|  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |  F7  |  F8  |  F9  |  F10 |  F11 |  F12 |
|------+------+------+------+------+------+------+------+------+------+------+------|
|      |   |  |  +   |  <   |  >   |  #   |   ~  |   (  |   )  |   \  |   :  |      |
|------+------+------+------+------+------+------+------+------+------+------+------|
|      |   !  |  -   |  =   |  %   |  @   |   _  |   {  |   }  |   /  |   ?  |      |
|------+------+------+------+------+------+------+------+------+------+------+------|
|MUSIC |   *  |  &   |  /   |  $   |  ^   |   |  |   [  |   ]  |      |      |      |
|------+------+------+------+------+------+------+------+------+------+------+------|
|      |  FN  |COLMAK|QWERTY|      |      |      |      |      |      |      |      |
`-----------------------------------------------------------------------------------'
```
### 5 Music
```
,-----------------------------------------------------------------------------------.
|      |      |      |      |      |      |      |      |      |      |      |      |
|------+------+------+------+------+------+------+------+------+------+------+------|
|      |      |      |      |      |      |      |      |      |      |      |      |
|------+------+------+------+------+------+------+------+------+------+------+------|
|      |      |      |      |      |      |      |      |      |      |      |      |
|------+------+------+------+------+------+------+------+------+------+------+------|
|      |      |      |      |      |      |      |      |      |      |      |      |
|------+------+------+------+------+------+------+------+------+------+------+------|
|COLMAK|      |      |      |      |      |      |      |      |      | MOD  | TOG  |
`-----------------------------------------------------------------------------------'
```