# Vosechu layout

This is my personal layout for the Shapeshifter. It's taken a long time to get 
to this point, but I think there are some things that are cool and special about
it. 

## Layout

Some special things:

* Lower/Raise are on the F/J keys. Tap to type the character, hold to activate the layer
* Enter and Backspace also activate the Lift layer.
* -- To get repeated backspace, hold BkLft and then press Shift


### Dvorak

    ,-----------------------------------------------------------------------------------.
    | Nada |   '  |   ,  |   .  |   P  |   Y  |   F  |   G  |   C  |   R  |   L  | Reset|
    |------+------+------+------+------+-------------+------+------+------+------+------|
    |  Esc |   A  |   O  |   E  | Lwr/U|   I  |   D  | Rse/H|   T  |   N  |   S  | Nada |
    |------+------+------+------+------+------|------+------+------+------+------+------|
    | Nada |   ;  |   Q  |   J  |   K  |   X  |   B  |   M  |   W  |   V  |   Z  | Enter|
    |------+------+------+------+------+------+------+------+------+------+------+------|
    | Nada |Ctrl/~|AltTab|  Cmd | BkLft| Shift| Space|EntLft|   -  |   =  |   /  |   \  |
    `-----------------------------------------------------------------------------------'

### Qwerty

    ,-----------------------------------------------------------------------------------.
    |  Tab |   Q  |   W  |   E  |   R  |   T  |   Y  |   U  |   I  |   O  |   P  | Back |
    |------+------+------+------+------+-------------+------+------+------+------+------|
    |  Esc |   A  |   S  |   D  | Lwr/F|   G  |   H  | Rse/J|   K  |   L  |   ;  |   "  |
    |------+------+------+------+------+------|------+------+------+------+------+------|
    | Shift|   Z  |   X  |   C  |   V  |   B  |   N  |   M  |   ,  |   .  |   /  | Enter|
    |------+------+------+------+------+------+------+------+------+------+------+------|
    | Hyper|Ctrl/~|AltTab|  Cmd | BkLft| Shift| Space|EntLft| Left | Down |  Up  | Right|
    `-----------------------------------------------------------------------------------'

### Raise

    ,-----------------------------------------------------------------------------------.
    |      |  <   |  >   |  {   |  }   |      |      |      |      |      |      |      |
    |------+------+------+------+------+-------------+------+------+------+------+------|
    |      |  (   |  )   |  [   |  ]   |      |      |      |      |      |      |      |
    |------+------+------+------+------+------|------+------+------+------+------+------|
    |      |      |      |      |      |      |      |      |      |      |      |      |
    |------+------+------+------+------+------+------+------+------+------+------+------|
    |      |      |      |      | BkLft| Shift| Space|EntLft|      |      |      |      |
    `-----------------------------------------------------------------------------------'

### Lower

    ,-----------------------------------------------------------------------------------.
    |      |      |      |      |      |      |      |   7  |   8  |   9  |      |      |
    |------+------+------+------+------+-------------+------+------+------+------+------|
    |      |      |      |      |      |      |      |   4  |   5  |   6  |      |      |
    |------+------+------+------+------+------|------+------+------+------+------+------|
    |      |      |      |      |      |      |      |   1  |   2  |   3  |      |      |
    |------+------+------+------+------+------+------+------+------+------+------+------|
    |      |      |      |      | BkLft| Shift| Space|   0  |   0  |   .  |      |      |
    `-----------------------------------------------------------------------------------'

### Lift

    ,-----------------------------------------------------------------------------------.
    |      |Hist ←| Tab ←|  ↑   | Tab →|Hist →| Mute |      |ScrLft|ScrFul|ScrRgt|      |
    |------+------+------+------+------+-------------+------+------+------+------+------|
    |      |      |  ←   |  ↓   |  →   | Pg Up|Vol up|Slk up|      |      |Qwerty|      |
    |------+------+------+------+------+------|------+------+------+------+------+------|
    |      |      |      |      |      | Pg Dn|Vol dn|Slk dn|      |      |Dvorak|      |
    |------+------+------+------+------+------+------+------+------+------+------+------|
    |      | Reset|      |      |      | Bksp |      | Shift|  Cmd |  Opt | Ctrl |      |
    `-----------------------------------------------------------------------------------'

Special things:

* Hist: Back button in your browser
* Tab: Move one tab left/right in most mac apps
* Slk: Go to the previous/next unread conversation in Slack
* Scr: Make this app fill the left/right side of your monitor (or full screen)
* Since arrows are on this layer, the command keys are moved to the right side
