# dlg's layout

[tshack's layout](https://github.com/qmk/qmk_firmware/tree/master/keyboards/tada68/keymaps/tshack), with:
 + Mac layer
   + Press Fn-I to align the bottom row to mac standards
 + volume controls moved to Fn+ M<>
 + Fn+Del for Insert
 + `GRAVE_ESC_ALT_OVERRIDE` so cmd-opt-esc still works (thx [mattdicarlo](https://github.com/qmk/qmk_firmware/tree/master/keyboards/tada68/keymaps/mattdicarlo))
 + `LALT` layer - LALT-4 maps to LALT-F4 so you can close windows in Windows


### Base Layer

```
,----------------------------------------------------------------.
|Esc | 1|  2|  3|  4|  5|  6|  7|  8|  9|  0|  -|  =|Backsp |~ ` |
|----------------------------------------------------------------|
|Tab  |  Q|  W|  E|  R|  T|  Y|  U|  I|  O|  P|  [|  ]|  \  |Del |
|----------------------------------------------------------------|
|Ctrl   |  A|  S|  D|  F|  G|  H|  J|  K|  L|  ;|  '|Return |PgUp|
|----------------------------------------------------------------|
|Shift   |  Z|  X|  C|  V|  B|  N|  M|  ,|  .|  /|Shift |Up |PgDn|
|----------------------------------------------------------------|
|Ctrl|Win |Alt |        Space          |Alt|Fn |Ctrl|<- |Dn | -> |
`----------------------------------------------------------------'
```
Note: 
* Shift + Esc = ~ (tilde)
* Win   + Esc = ` (grave)


### Fn Layer

```
,----------------------------------------------------------------.
|   |F1 |F2 |F3 |F4 |F5 |F6 |F7 |F8 |F9 |F10|F11|F12|  Del  |    |
|----------------------------------------------------------------|
|     |BL |BL-|BL+|   |   |   |   |mac|   |PSc|   |   |     |Ins |
|----------------------------------------------------------------|
|      |   |   |   |   |   |<- |Dn |Up | ->|   |   |        |Hme |
|----------------------------------------------------------------|
|        |   |   |   |   |   |   |MUT|V- |V+ |   |      |PUp|End |
|----------------------------------------------------------------|
|    |    |    |                       |   |   |    |Hme|PDn|End |
`----------------------------------------------------------------'
```

### Mac Layer

```
,----------------------------------------------------------------.
|   |   |   |   |   |   |   |   |   |   |   |   |   |       |    |
|----------------------------------------------------------------|
|     |   |   |   |   |   |   |   |   |   |   |   |   |     |    |
|----------------------------------------------------------------|
|      |   |   |   |   |   |   |   |   |   |   |   |        |    |
|----------------------------------------------------------------|
|        |   |   |   |   |   |   |   |   |   |   |      |   |    |
|----------------------------------------------------------------|
|Ctrl|Alt |Win |                       |Win |   |Alt|   |   |    |
`----------------------------------------------------------------'
```

### `LALT` Layer

```
,----------------------------------------------------------------.
|   |   |   |   |F4 |   |   |   |   |   |   |   |   |       |    |
|----------------------------------------------------------------|
|     |   |   |   |   |   |   |   |   |   |   |   |   |     |    |
|----------------------------------------------------------------|
|      |   |   |   |   |   |   |   |   |   |   |   |        |    |
|----------------------------------------------------------------|
|        |   |   |   |   |   |   |   |   |   |   |      |   |    |
|----------------------------------------------------------------|
|    |Alt |    |                       |    |   |   |   |   |    |
`----------------------------------------------------------------'
```
