/* Copyright 2021 Shulin Huang <mumu@x-bows.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include QMK_KEYBOARD_H

const uint16_t PROGMEM keymaps[][MATRIX_ROWS][MATRIX_COLS] = {
  /* Keymap VANILLA: (Base Layer) Default Layer
   *
   * |---------------------------------------------------------------------------------------------------------------------------------------------------------------|
   * | Esc |        F1 |  F2 |  F3 |  F4 |     F5 |  F6 |  F7 |  F8 |    F9 | F10 | F11 | F12 |      Print |S-Lock|Pause
   * |---------------------------------------------------------------------------------------------------------------------------------------------------------------|
   * |  ~  |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |  9  |  0  |  -  |  =  | Backspace|      Insert| Home |PgUp
   * |---------------------------------------------------------------------------------------------------------------------------------------------------------------|
   * |  Tab  |  Q  |  W  |  E  |  R  |  T  |  Y  |  U  |  I  |  O  |  P  |  [  |  ]  |   \    |      Delete|  End |PgDn
   * |---------------------------------------------------------------------------------------------------------------------------------------------------------------|
   * |  Caps  |  A  |  S  |  D  |  F  |  G  |  H  |  J  |  K  |  L  |  ;  |  '"  |   Enter    |
   * |---------------------------------------------------------------------------------------------------------------------------------------------------------------|
   * |   Shift  |  Z  |  X  |  C  |  V  |  B  |  N  |  M  |  ,  |  .  |  /? |      Shift      |            |  Up  |
   * |---------------------------------------------------------------------------------------------------------------------------------------------------------------|
   * | Ctrl | GUI |Alter|                Space                 | Alter|  Fn  |  menu |  Ctrl  |       Left | Down |Right
   * |---------------------------------------------------------------------------------------------------------------------------------------------------------------|
   */
  [0] = LAYOUT_tkl_ansi(
		KC_ESC,         KC_F1, KC_F2, KC_F3, KC_F4,    KC_F5, KC_F6, KC_F7, KC_F8,    KC_F9,KC_F10,KC_F11,KC_F12,      KC_PSCR,  KC_SLCK,  KC_PAUS,
		KC_GRV,  KC_1,  KC_2,  KC_3,  KC_4,  KC_5,  KC_6,  KC_7,  KC_8,  KC_9,  KC_0,KC_MINS, KC_EQL,  KC_BSPC  ,      KC_INS,   KC_HOME,  KC_PGUP,
		KC_TAB,    KC_Q,  KC_W,  KC_E,  KC_R,  KC_T,  KC_Y,  KC_U,  KC_I,  KC_O,  KC_P,KC_LBRC,KC_RBRC,  KC_BSLS,      KC_DEL,   KC_END,   KC_PGDN,
		KC_CAPS,    KC_A,  KC_S,  KC_D,  KC_F,  KC_G,  KC_H,  KC_J,  KC_K,  KC_L, KC_SCLN ,KC_QUOT,    KC_ENT   ,
		KC_LSFT,     KC_Z,  KC_X,  KC_C,  KC_V,  KC_B,  KC_N,  KC_M,  KC_COMM, KC_DOT, KC_SLSH,     KC_RSFT     ,                KC_UP,
		KC_LCTL, KC_LGUI,KC_LALT,                  KC_SPC,                 KC_RALT,    MO(1)  , KC_APP, KC_RCTL,      KC_LEFT,  KC_DOWN,  KC_RGHT),
  [1] = LAYOUT_tkl_ansi(
    RESET,             KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS,      KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS,       KC_CALC, KC_MYCM, KC_MSEL, KC_MAIL,      NK_TOGG,  EEP_RST,  KC_NLCK,
    KC_TRNS,  KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS,        KC_TRNS,          KC_TRNS,  KC_TRNS,  KC_TRNS,
    RGB_TOG,     RGB_MOD, RGB_VAI, RGB_HUI, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS,      KC_TRNS,         KC_TRNS,  KC_TRNS,  KC_TRNS,
    KC_TRNS,        RGB_SPD, RGB_VAD, RGB_SPI, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS,         KC_TRNS,
    KC_TRNS,           KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS, KC_TRNS,              KC_MUTE,                       KC_VOLU,
    KC_TRNS,   KC_TRNS,   KC_TRNS,                              KC_TRNS,                            KC_TRNS,   KC_TRNS,   KC_TRNS,   KC_MPLY,      KC_MPRV,  KC_VOLD,  KC_MNXT)
};
