# Choromanski

## Features
* Colemak
* Qwerty
* Toggable function row
* Symbol layer programmer friendly
* Numpad/Mouse layer with media controls
* Gaming friendly layer

## Layers

### 0 Colemak
```
,--------------------------------------------------.         ,--------------------------------------------------.
|   ` ~  |  1 ! | 2 @  | 3 #  | 4 $  | 5 %  |  6 ^ |         | 7 &  |  8 * | 9 (  |  0 ) | - _  | = +  | BSPACE |
|--------+------+------+------+------+-------------|         |------+------+------+------+------+------+--------|
|   TAB  |   Q  |   W  |   F  |   P  |   G  |      |         |      |   J  |   L  |   U  |   Y  |  ; : |  \ |   |
|--------+------+------+------+------+------|  (   |         |   )  |------+------+------+------+------+--------|
|   ESC  |   A  |   R  |   S  |   T  |   D  |------|         |------|   H  |   N  |   E  |   I  |   O  |  ' "   |
|--------+------+------+------+------+------|  {   |         |   }  |------+------+------+------+------+--------|
| Shift  |CTR(Z)|GUI(X)|ALT(C)|   V  |   B  |  [   |         |   ]  |   K  |   M  |  , < |ALT(.)|CTR(/)| Shift  |
`--------+------+------+------+------+-------------'         `-------------+------+------+------+------+--------'
  |OSL(3)| TG(2)| TO(5)| TO(1)| CAPS |                                      | LEFT | DOWN |  UP  |RIGHT |TG(4)|
  `----------------------------------'                                      `---------------------------------'
                                     ,--------------.       ,--------------.
                                     | LCTR | LALT  |       | RALT | RCTR  |
                              ,------|------|-------|       |------+-------+------.
                              |      |      | MUTE  |       |SCROLU|       |      |
                              |BSPACE|DELETE|-------|       |------| ENTER |SPACE |
                              |      |      |  GUI  |       |SCROLD|       |      |
                              `---------------------'       `---------------------'
```
### 1 Qwerty
```
,--------------------------------------------------.         ,--------------------------------------------------.
|        |      |      |      |      |      |      |         |      |      |      |      |      |      |   ESC  |
|--------+------+------+------+------+-------------|         |------+------+------+------+------+------+--------|
|        |   Q  |   W  |   E  |   R  |   T  |      |         |      |   Y  |   U  |   I  |   O  |   P  |        |
|--------+------+------+------+------+------|      |         |      |------+------+------+------+------+--------|
|  CAPS  |   A  |   S  |   D  |   F  |   G  |------|         |------|   H  |   J  |   K  |   L  |   ;  |        |
|--------+------+------+------+------+------|      |         |      |------+------+------+------+------+--------|
|        |CTL(Z)|GUI(X)|ALT(C)|   V  |   B  |      |         |      |   N  |   M  |  , < |ALT(.)|CTL(/)|        |
`--------+------+------+------+------+-------------'         `-------------+------+------+------+------+--------'
  |OSL(3)| TG(2)| TO(5)| TO(0)|      |                                     |      |      |      |      | TG(4)|
  `----------------------------------'                                     `----------------------------------'
                                     ,-------------.        ,--------------.
                                     |      |      |        |      |       |
                              ,------|------|------|        |------+-------+------.
                              |      |      |      |        |      |       |      |
                              |      |      |------|        |------|       |      |
                              |      |      |      |        |      |       |      |
                              `--------------------'        `---------------------'
```
### 2 Function Lock
```
,--------------------------------------------------.         ,--------------------------------------------------.
|        |  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |         |  F7  |  F8  |  F9  |  F10 |  F11 |  F12 |        |
|--------+------+------+------+------+-------------|         |------+------+------+------+------+------+--------|
|        |      |      |      |      |      |      |         |      |      |      |      |      |      |        |
|--------+------+------+------+------+------|      |         |      |------+------+------+------+------+--------|
|        |      |      |      |      |      |------|         |------|      |      |      |      |      |        |
|--------+------+------+------+------+------|      |         |      |------+------+------+------+------+--------|
|        |      |      |      |      |      |      |         |      |      |      |      |      |      |        |
`--------+------+------+------+------+-------------'         `-------------+------+------+------+------+--------'
  |      |      |      |      |      |                                     |      |      |      |      |      |
  `----------------------------------'                                     `----------------------------------'
                                     ,-------------.        ,--------------.
                                     |      |      |        |      |       |
                              ,------|------|------|        |------+-------+------.
                              |      |      |      |        |      |       |      |
                              |      |      |------|        |------|       |      |
                              |      |      |      |        |      |       |      |
                              `--------------------'        `---------------------'
```
### 3 Symbols
```
,--------------------------------------------------.         ,--------------------------------------------------.
|        |  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |         |  F7  |  F8  |  F9  |  F10 |  F11 |  F12 |        |
|--------+------+------+------+------+-------------|         |------+------+------+------+------+------+--------|
|        |  |   |  +   |  <   |  >   |  #   |      |         |      |   ~  |   (  |   )  |   \  |   :  |        |
|--------+------+------+------+------+------|      |         |      |------+------+------+------+------+--------|
|        |  !   |  -   |  =   |  %   |  @   |------|         |------|   _  |   {  |   }  |   /  |   ?  |        |
|--------+------+------+------+------+------|      |         |      |------+------+------+------+------+--------|
|        |  *   |  &   |  /   |  $   |  ^   |      |         |      |   |  |   [  |   ]  |      |      |        |
`--------+------+------+------+------+-------------'         `-------------+------+------+------+------+--------'
  |      |      |      |      |      |                                     |      |      |      |      |      |
  `----------------------------------'                                     `----------------------------------'
                                     ,-------------.        ,--------------.
                                     |      |      |        |      |       |
                              ,------|------|------|        |------+-------+------.
                              |      |      |      |        |      |       |      |
                              |      |      |------|        |------|       |      |
                              |      |      |      |        |      |       |      |
                              `--------------------'        `---------------------'
```
### 4 Numpad/Mouse with Media Controls
```
,--------------------------------------------------.         ,--------------------------------------------------.
| POWER  |SLEEP |      |MOUSE3|      |      | RESET|         |RESET |SCROL | NUML |  /   |   |  -   |        |
|--------+------+------+------+------+-------------|         |------+------+------+------+------+------+--------|
|        |      |MOUSE1|MOUSEU|MOUSE2|SCROLU|      |         |      |      |  7   |  8   |  9   |  +   | ACCEL0 |
|--------+------+------+------+------+------|      |         |      |------+------+------+------+------+--------|
|        |      |MOUSEL|MOUSED|MOUSER|SCROLD|------|         |------|      |  4   |  5   |  6   |  +   | ACCEL1 |
|--------+------+------+------+------+------|      |         |      |------+------+------+------+------+--------|
|        |      |ACCEL0|ACCEL1|ACCEL2|      |      |         |      |      |  1   |  2   |  3   |ENTER | ACCEL2 |
`--------+------+------+------+------+-------------'         `-------------+------+------+------+------+--------'
  |      |      |      |      |      |                                     |  0   |  0   |  .   |ENTER |      |
  `----------------------------------'                                     `----------------------------------'
                                     ,-------------.        ,-------------.
                                     | VOL+ | VOL- |        |MEDIA<|MEDIA>|
                              ,------|------|------|        |------+------+------.
                              |      |      | MUTE |        |Pause |      |      |
                              |      |      |------|        |------|      |      |
                              |      |      |FILES |        | CALC |      |      |
                              `--------------------'        `--------------------'
```
### 5 Gaming
```
,--------------------------------------------------.        ,--------------------------------------------------.
|   ` ~  |  1 ! | 2 @  | 3 #  | 4 $  | 5 %  |  6 ^ |        | 7 &  |  8 * | 9 (  |  0 ) | - _  | = +  |  ESC   |
|--------+------+------+------+------+-------------|        |------+------+------+------+------+------+--------|
|   TAB  |   Q  |   W  |   E  |   R  |   T  |      |        |      |   Y  |   U  |   I  |   O  |  P   |  \ |   |
|--------+------+------+------+------+------|  (   |        |   )  |------+------+------+------+------+--------|
|   LCTR |   A  |   S  |   D  |   F  |   G  |------|        |------|   H  |   J  |   K  |   L  |  ; : |  ' "   |
|--------+------+------+------+------+------| MEDIA|        |   }  |------+------+------+------+------+--------|
| LShift |   Z  |   X  |   C  |   V  |   B  |  P/P |        |   ]  |   K  |   M  |  UP  |  . > |  / ? | Shift  |
`--------+------+------+------+------+-------------'        `-------------+------+------+------+------+--------'
  | LCTR |ALTTAB| TO(0)| ALT  | SPACE|                                    | LEFT | DOWN | RIGHT|  , < |TO(0) |
  `----------------------------------'                                    `----------------------------------'
                                     ,--------------.       ,--------------.
                                     |MEDIA<| MEDIA>|       | RALT | RCTR  |
                              ,------|------|-------|       |------+-------+------.
                              |      |      | VOL+  |       | PGUP |       |      |
                              |SPACE |ENTER |-------|       |------|BSPACE |DELETE|
                              |      |      | VOL-  |       | PGDWN|       |      |
                              `---------------------'       `---------------------'
```