# ErgoDox EZ Code Friendly Colemak Layout

  _This layout was inspired by qwerty_code_friendly layout._ 

  Having all the symbols accessible without modifiers is a good improvement for coding.

  There are only two layouts which is easy to memorize.

  There are two _"Super shifts"_, LNUM and RNUM, placed on the most convenient physical keys. Each of them act as shift for the opposite side of the keyboard, and as a modifier key for the current side (usage similar to AltGr in many national layouts). This is achieved by duplicating the corresponding parts of Layer 0 and 1 into Layer 3 and 4. As a bonus, pressing both keys toggles Caps-Lock.
  
  The numerical keypad is composed from regular number keys, works even in macOS.

## Keymap 0: Basic layer

```
.--------------------------------------------------.  .--------------------------------------------------.
| Grave  |   !  |   @  |   #  |   $  |   %  |   ^  |  | TG(1)|   &  |   *  |   (  |   )  |   -  |  Bspc  |
|--------+------+------+------+------+------+------|  |------+------+------+------+------+------+--------|
| Tab    |   Q  |   W  |   F  |   P  |   G  |   =  |  |  _   |   J  |   L  |   U  |   Y  |   ;  |   \    |
|--------+------+------+------+------+------|      |  |      |------+------+------+------+------+--------|
| Esc    |   A  |   R  |   S  |   T  |   D  |------|  |------|   H  |   N  |   E  |   I  |   O  |  '     |
|--------+------+------+------+------+------|   {  |  |  }   |------+------+------+------+------+--------|
| LShift |Z/LCtl|X/Supe|   C  |   V  |B/RAlt|      |  |      |K/RAlt|   M  |   ,  |./Supe|/ RCtl| RShift |
'--------+------+------+------+------+-------------'  '-------------+------+------+------+------+--------'
  | LCtl |Super | Alt  |   [  |   ]  |                              | Left | Down | Up   |Right | Del  |
  '----------------------------------'                              '----------------------------------'
                                     .-------------.  .-------------.
                                     | Home | End  |  | Ins  |ScrLck|
                              .------+------+------|  |------+------+------.
                              |      |      |PrnScr|  | PgUp |      |      |
                              | LNUM | Enter|------|  |------| Space| RNUM |
                              |      |      | Super|  | PgDn |      |      |
                              '--------------------'  '--------------------'
```

## Keymap 1: Numbers, Macro Record


```
.--------------------------------------------------.  .--------------------------------------------------.
|        |      |      |      |      |  <>  |      |  |      |      |   *  |   (  |  )   |  -   |        |
|--------+------+------+------+------+------+------|  |------+------+------+------+------+------+--------|
|        |  F12 |  F11 |  F10 |  F9  |  {}  |      |  |  =   |  =>  |   7  |   8  |   9  |  +   |        |
|--------+------+------+------+------+------|      |  |      |------+------+------+------+------+--------|
|        |  F8  |  F7  |  F6  |  F5  |  ()  |------|  |------|  ->  |   4  |   5  |   6  |  0   |        |
|--------+------+------+------+------+------|      |  | Enter|------+------+------+------+------+--------|
|        |  F4  |  F3  |  F2  |  F1  |  []  |      |  |      |  !=  |   1  |   2  |   3  |      |        |
'--------+------+------+------+------+-------------'  '-------------+------+------+------+------+--------'
  | MUTE | VOLD | VOLU |      |      |                              |   0  |   ,  |   .  |      |      |
  '----------------------------------'                              '----------------------------------'
                                     .-------------.  .-------------.
                                     |      |      |  |      | Stop |
                              .------+------+------|  |------+------+------.
                              |      |      |Start1|  |Start2|      |      |
                              |      |      |------|  |------|      |      |
                              |      |      |Play1 |  |Play2 |      |      |
                              '--------------------'  '--------------------'
```

## Keymap 2: Left side -> LAYER_NUM,                             Right side -> Shift + LAYER_BASE


```
.--------------------------------------------------.  .--------------------------------------------------.
|        |      |      |      |      |  <>  |      |  | TG(1)|   &  |   *  |   (  |   )  |   -  |  Bspc  |
|--------+------+------+------+------+------+------|  |------+------+------+------+------+------+--------|
|        |  F12 |  F11 |  F10 |  F9  |  {}  |      |  |  _   |   J  |   L  |   U  |   Y  |   ;  |   \    |
|--------+------+------+------+------+------|      |  |      |------+------+------+------+------+--------|
|        |  F8  |  F7  |  F6  |  F5  |  ()  |------|  |------|   H  |   N  |   E  |   I  |   O  |  '     |
|--------+------+------+------+------+------|      |  |  }   |------+------+------+------+------+--------|
|        |  F4  |  F3  |  F2  |  F1  |  []  |      |  |      |K/RAlt|   M  |   ,  |./Supe|/ RCtl| RShift |
'--------+------+------+------+------+-------------'  '-------------+------+------+------+------+--------'
  | MUTE | VOLD | VOLU |      |      |                              | Left | Down | Up   |Right | Del  |  
  '----------------------------------'                              '----------------------------------'  
                                     .-------------.  .-------------.
                                     |      |      |  | Ins  |ScrLck|
                              .------+------+------|  |------+------+------.
                              |      |      |Start1|  | PgUp |      |      |
                              |      |      |------|  |------| Space|CapsLk|
                              |      |      |Play1 |  | PgDn |      |      |
                              '--------------------'  '--------------------'
```

## Keymap 3: Left side -> Shift + LAYER_BASE,                    Right side -> LAYER_NUM


```
.--------------------------------------------------.  .--------------------------------------------------.
| Grave  |   !  |   @  |   #  |   $  |   %  |   ^  |  |      |      |   *  |   (  |  )   |  -   |        |
|--------+------+------+------+------+------+------|  |------+------+------+------+------+------+--------|
| Tab    |   Q  |   W  |   F  |   P  |   G  |   =  |  |  =   |  =>  |   7  |   8  |   9  |  +   |        |
|--------+------+------+------+------+------|      |  |      |------+------+------+------+------+--------|
| Esc    |   A  |   R  |   S  |   T  |   D  |------|  |------|  ->  |   4  |   5  |   6  |  0   |        |
|--------+------+------+------+------+------|   {  |  | Enter|------+------+------+------+------+--------|
| LShift |Z/LCtl|X/Supe|   C  |   V  |B/RAlt|      |  |      |  !=  |   1  |   2  |   3  |      |        |
'--------+------+------+------+------+-------------'  '-------------+------+------+------+------+--------'
  | LCtl |Super | Alt  |   [  |   ]  |                              |   0  |   ,  |   .  |      |      |
  '----------------------------------'                              '----------------------------------'
                                     .-------------.  .-------------.
                                     | Home | End  |  |      | Stop |
                              .------+------+------|  |------+------+------.
                              |      |      |PrnScr|  |Start2|      |      |
                              |CapsLk| Enter|------|  |------|      |      |
                              |      |      | Super|  |Play2 |      |      |
                              '--------------------'  '--------------------'
```
